﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.8
@EndOfDesignText@
  'Code module

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.
	Private PageChartsAndGraphs As Page
	Private btnNext, btnPrevious As Button
	
	Private xui As XUI
	
	'My Charts
	Private PieChartEmployers As xChart
	Private PieChart2Employers As xChart
	Private PieChartCashCredit As xChart
	Private LineChartAvgTips As xChart
	Private BarChartBestTipDays As xChart
	Private StackedBarChartActualVsMin As xChart
	Private BarChartEarningsPerHour As xChart
	Private PieChartTipRetention As xChart
	Private PieChartMileage As xChart
	Private BarChartBestTipHours As xChart
	Private BarChartDeliveriesByHour As xChart
	Private BarChartDeliveriesByDay As xChart
	
	Private pnlCharts As Panel
	Private labelExplanation As Label
		
	Private nCashTipRatio As Double
	Private nCreditTipRatio As Double

	Private SelectedChart = 1 As Int


End Sub

Public Sub ShowChartsAndGraphs
	PageChartsAndGraphs.Initialize("PageChartsAndGraphs")
	
	ResetLayout  'Localize
	
	'Set gradiant color to panel
	GlobalFunctions.SetTheme(pnlCharts, False)
	
	Main.NavControl.ShowPage(PageChartsAndGraphs)

	ShowChart(SelectedChart)

End Sub

Private Sub CreatePieDataEmployers
	'Employer Comparison Tips
	PieChartEmployers.ClearData
	PieChartEmployers.Title = Main.Localize.Localize("Employer Comparison Tips")
	
	Dim ResultSet1 As ResultSet
	Dim Query1 As String
	Dim nTotalTips As Double
	Dim cEmployer As String
	Dim nTipRatio As Double
	Dim nEmployerTips As Double

	labelExplanation.Text = Main.Localize.Localize("This chart shows the percentages of your total tip income from all the employers for whom you work.")

	'Get Total Tips
	nTotalTips = GlobalFunctions.GetTotalTips(Main.Localize.Localize("All"), "2000-01-01", "2099-12-31")  '====================================

	'Get Total Tips from each Employer
	Query1 = "SELECT DISTINCT Employer FROM employers"
	ResultSet1 = Main.SQL1.ExecQuery(Query1)
	Do While ResultSet1.NextRow
		cEmployer = ResultSet1.GetString("Employer")
		nEmployerTips = GlobalFunctions.GetTotalTips(cEmployer, "2000-01-01", "2099-12-31")

		'Get Tip Ratio
		nTipRatio = (nEmployerTips / nTotalTips) * 360
	
		'Create Pie slice
		PieChartEmployers.AddPie(cEmployer, nTipRatio, 0) '0 = random color
		
	Loop
	ResultSet1.Close
	
	PieChartEmployers.DrawChart
	
End Sub

Private Sub CreatePieData2Employers
	'Employer Comparison Delivery Fees
	PieChart2Employers.ClearData
	PieChart2Employers.Title = Main.Localize.Localize("Employer Comparison Fees")
	
	Dim ResultSet1 As ResultSet
	Dim Query1 As String
	Dim nTotalFees As Double
	Dim cEmployer As String
	Dim nFeeRatio As Double
	Dim nEmployerFees As Double

	labelExplanation.Text = Main.Localize.Localize("This chart shows the percentages of your total delivery fee income from all the employers for whom you work.")
	
	'Get Total Delivery Fees
	nTotalFees = GlobalFunctions.GetTotalDeliveryFees(Main.Localize.Localize("All"), "2000-01-01", "2099-12-31")   '====================================

	'Get Total Tips from each Employer
	Query1 = "SELECT DISTINCT Employer FROM employers"
	ResultSet1 = Main.SQL1.ExecQuery(Query1)
	Do While ResultSet1.NextRow
		cEmployer = ResultSet1.GetString("Employer")
		nEmployerFees = GlobalFunctions.GetTotalDeliveryFees(cEmployer, "2000-01-01", "2099-12-31")

		'Get Tip Ratio
		nFeeRatio = (nEmployerFees / nTotalFees) * 360
		If GlobalFunctions.IsNaN(nFeeRatio) Then
			nFeeRatio = 0
		End If
		
		'Create Pie slice
		PieChart2Employers.AddPie(cEmployer, nFeeRatio, 0) '0 = random color
		
	Loop
	ResultSet1.Close
	
	PieChart2Employers.DrawChart

End Sub

Private Sub btnNext_click
	SelectedChart = SelectedChart + 1
	If SelectedChart >= 1 And SelectedChart <= 12 Then
		ShowChart(SelectedChart)
	End If
End Sub

Private Sub btnPrevious_click
	SelectedChart = SelectedChart - 1
	If SelectedChart >= 1 And SelectedChart <= 12 Then
		ShowChart(SelectedChart)
	End If
End Sub

Private Sub CreatePieDataCashCredit
	'Cash vs Credit chart
	PieChartCashCredit.ClearData
	PieChartCashCredit.Title = Main.Localize.Localize("Cash vs Credit")
	
	labelExplanation.Text = Main.Localize.Localize("This chart shows the total percentage of all cash tips versus credit tips recieved for all records.")
	
	GetTipRatios
	
	PieChartCashCredit.AddPie(Main.Localize.Localize("Cash"), nCashTipRatio, xui.Color_Blue) '0 = random color
	PieChartCashCredit.AddPie(Main.Localize.Localize("Credit"), nCreditTipRatio, xui.Color_Red)
	
	PieChartCashCredit.DrawChart
End Sub
	
Private Sub CreateLineChartAvgTips
	' Initialize the line data
	LineChartAvgTips.ClearData
	
	labelExplanation.Text = Main.Localize.Localize("This chart shows the previous year's average tip compared to the current year's average tip on a month to month basis for all employers.")
		
	LineChartAvgTips.AddLine(Main.Localize.Localize("This Year"), xui.Color_Blue) '0 = random color
	LineChartAvgTips.AddLine(Main.Localize.Localize("Last Year"), xui.Color_Red)

	Dim nYear As Int
	Dim cBOM As String
	Dim cEOM As String
	Dim nLastYear As Int
	Dim x As String
	Dim y As Double
	Dim y2 As Double

	nYear = DateTime.GetYear(DateTime.Now)  'Year
	nLastYear = nYear - 1

	For i = 1 To 12
		If i = 1 Then
			x = Main.Localize.Localize("Jan")
			cBOM = nYear & "-01-01"		'Format First of month date
			cEOM = nYear & "-01-31" 	'Format End of month date
			'Get Average Tips
			y = GetTotalAvgTips(cBOM, cEOM)
			'Last Year
			cBOM = nLastYear & "-01-01"		'Format First of month date
			cEOM = nLastYear & "-01-31" 	'Format End of month date
			'Get Average Tips
			y2 = GetTotalAvgTips(cBOM, cEOM)
		End If
		If i = 2 Then
			x = Main.Localize.Localize("Feb")
			cBOM = nYear & "-02-01"		'Format First of month date
			cEOM = nYear & "-02-29" 	'Format End of month date
			'Get Average Tips
			y = GetTotalAvgTips(cBOM, cEOM)
			'Last Year
			cBOM = nLastYear & "-02-01"		'Format First of month date
			cEOM = nLastYear & "-02-29" 	'Format End of month date
			'Get Average Tips
			y2 = GetTotalAvgTips(cBOM, cEOM)
		End If
		If i = 3 Then
			x = Main.Localize.Localize("Mar")
			cBOM = nYear & "-03-01"		'Format First of month date
			cEOM = nYear & "-03-31" 	'Format End of month date
			'Get Average Tips
			y = GetTotalAvgTips(cBOM, cEOM)
			'Last Year
			cBOM = nLastYear & "-03-01"		'Format First of month date
			cEOM = nLastYear & "-03-31" 	'Format End of month date
			'Get Average Tips
			y2 = GetTotalAvgTips(cBOM, cEOM)
		End If
		If i = 4 Then
			x = Main.Localize.Localize("Apr")
			cBOM = nYear & "-04-01"		'Format First of month date
			cEOM = nYear & "-04-30" 	'Format End of month date
			'Get Average Tips
			y = GetTotalAvgTips(cBOM, cEOM)
			'Last Year
			cBOM = nLastYear & "-04-01"		'Format First of month date
			cEOM = nLastYear & "-04-30" 	'Format End of month date
			'Get Average Tips
			y2 = GetTotalAvgTips(cBOM, cEOM)
		End If
		If i = 5 Then
			x = Main.Localize.Localize("May")
			cBOM = nYear & "-05-01"		'Format First of month date
			cEOM = nYear & "-05-31" 	'Format End of month date
			'Get Average Tips
			y = GetTotalAvgTips(cBOM, cEOM)
			'Last Year
			cBOM = nLastYear & "-05-01"		'Format First of month date
			cEOM = nLastYear & "-05-31" 	'Format End of month date
			'Get Average Tips
			y2 = GetTotalAvgTips(cBOM, cEOM)
		End If
		If i = 6 Then
			x = Main.Localize.Localize("Jun")
			cBOM = nYear & "-06-01"		'Format First of month date
			cEOM = nYear & "-06-30" 	'Format End of month date
			'Get Average Tips
			y = GetTotalAvgTips(cBOM, cEOM)
			'Last Year
			cBOM = nLastYear & "-06-01"		'Format First of month date
			cEOM = nLastYear & "-06-30" 	'Format End of month date
			'Get Average Tips
			y2 = GetTotalAvgTips(cBOM, cEOM)
		End If
		If i = 7 Then
			x = Main.Localize.Localize("Jul")
			cBOM = nYear & "-07-01"		'Format First of month date
			cEOM = nYear & "-07-31" 	'Format End of month date
			'Get Average Tips
			y = GetTotalAvgTips(cBOM, cEOM)
			'Last Year
			cBOM = nLastYear & "-07-01"		'Format First of month date
			cEOM = nLastYear & "-07-31" 	'Format End of month date
			'Get Average Tips
			y2 = GetTotalAvgTips(cBOM, cEOM)
		End If
		If i = 8 Then
			x = Main.Localize.Localize("Aug")
			cBOM = nYear & "-08-01"		'Format First of month date
			cEOM = nYear & "-08-31" 	'Format End of month date
			'Get Average Tips
			y = GetTotalAvgTips(cBOM, cEOM)
			'Last Year
			cBOM = nLastYear & "-08-01"		'Format First of month date
			cEOM = nLastYear & "-08-31" 	'Format End of month date
			'Get Average Tips
			y2 = GetTotalAvgTips(cBOM, cEOM)
		End If
		If i = 9 Then
			x = Main.Localize.Localize("Sep")
			cBOM = nYear & "-09-01"		'Format First of month date
			cEOM = nYear & "-09-30" 	'Format End of month date
			'Get Average Tips
			y = GetTotalAvgTips(cBOM, cEOM)
			'Last Year
			cBOM = nLastYear & "-09-01"		'Format First of month date
			cEOM = nLastYear & "-09-30" 	'Format End of month date
			'Get Average Tips
			y2 = GetTotalAvgTips(cBOM, cEOM)
		End If
		If i = 10 Then
			x = Main.Localize.Localize("Oct")
			cBOM = nYear & "-10-01"		'Format First of month date
			cEOM = nYear & "-10-31" 	'Format End of month date
			'Get Average Tips
			y = GetTotalAvgTips(cBOM, cEOM)
			'Last Year
			cBOM = nLastYear & "-10-01"		'Format First of month date
			cEOM = nLastYear & "-10-31" 	'Format End of month date
			'Get Average Tips
			y2 = GetTotalAvgTips(cBOM, cEOM)
		End If
		If i = 11 Then
			x = Main.Localize.Localize("Nov")
			cBOM = nYear & "-11-01"		'Format First of month date
			cEOM = nYear & "-11-30" 	'Format End of month date
			'Get Average Tips
			y = GetTotalAvgTips(cBOM, cEOM)
			'Last Year
			cBOM = nLastYear & "-11-01"		'Format First of month date
			cEOM = nLastYear & "-11-30" 	'Format End of month date
			'Get Average Tips
			y2 = GetTotalAvgTips(cBOM, cEOM)
		End If
		If i = 12 Then
			x = Main.Localize.Localize("Dec")
			cBOM = nYear & "-12-01"		'Format First of month date
			cEOM = nYear & "-12-31" 	'Format End of month date
			'Get Average Tips
			y = GetTotalAvgTips(cBOM, cEOM)
			'Last Year
			cBOM = nLastYear & "-12-01"		'Format First of month date
			cEOM = nLastYear & "-12-31" 	'Format End of month date
			'Get Average Tips
			y2 = GetTotalAvgTips(cBOM, cEOM)
		End If
		
		LineChartAvgTips.AddBarMultiplePoint(x, Array As Double(y, y2))
	Next
	
	LineChartAvgTips.Title = Main.Localize.Localize("Year Over Year")
	LineChartAvgTips.XAxisName = Main.Localize.Localize("Month")
	LineChartAvgTips.YAxisName = Main.Localize.Localize("Avg Tip")
	LineChartAvgTips.YScaleMaxValue = 1
	LineChartAvgTips.YScaleMinValue = -1
	LineChartAvgTips.AutomaticScale = True
	LineChartAvgTips.XScaleTextOrientation = "45 DEGREES"
	
	LineChartAvgTips.DrawChart
End Sub

Private Sub CreateBarChartBestTipDays
	
	labelExplanation.Text = Main.Localize.Localize("This chart shows the average tip for each day of the week for the currently active Employer Profile.")
	
	'Create Bar Chart
	BarChartBestTipDays.ClearData
	BarChartBestTipDays.Title = Main.Localize.Localize("Best Tipping Days")
	BarChartBestTipDays.TitleTextColor = xui.Color_Black
	BarChartBestTipDays.AddBar(Main.Localize.Localize("Avg Tip"), xui.Color_Blue)
	BarChartBestTipDays.XScaleTextOrientation = "45 DEGREES"
	BarChartBestTipDays.BarValueOrientation = "VERTICAL"
	BarChartBestTipDays.ScaleTextColor = xui.Color_Black
	BarChartBestTipDays.SetBarMeanValueFormat(1, 2, 2, False)
	BarChartBestTipDays.XAxisName = Main.Localize.Localize("Day of Week")
	BarChartBestTipDays.YAxisName = Main.Localize.Localize("Tip Amount")
	
	Dim x As String
	Dim y As Double
	Dim Query As String
	
	'Create Bars...Mon-Sun  LM X J V S D
	For i = 1 To 7
		Select i
			Case 1
				Query = "SELECT AVG(TipAmount) As 'TotalTips' FROM tips where TipDate = date(TipDate,'weekday 1') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Mon")
				y = NumberFormat2(GetDayTipAvg(Query), 0, 2, 2, True)
				
				BarChartBestTipDays.AddBarPointData(x, y)
			Case 2
				Query = "SELECT AVG(TipAmount) As 'TotalTips' FROM tips where TipDate = date(TipDate,'weekday 2') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Tue")
				y = NumberFormat2(GetDayTipAvg(Query), 0, 2, 2, True)
				
				BarChartBestTipDays.AddBarPointData(x, y)
			Case 3
				Query = "SELECT AVG(TipAmount) As 'TotalTips' FROM tips where TipDate = date(TipDate,'weekday 3') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Wed")
				y = NumberFormat2(GetDayTipAvg(Query), 0, 2, 2, True)
				
				BarChartBestTipDays.AddBarPointData(x, y)
			Case 4
				Query = "SELECT AVG(TipAmount) As 'TotalTips' FROM tips where TipDate = date(TipDate,'weekday 4') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Thu")
				y = NumberFormat2(GetDayTipAvg(Query), 0, 2, 2, True)
				
				BarChartBestTipDays.AddBarPointData(x, y)
			Case 5
				Query = "SELECT AVG(TipAmount) As 'TotalTips' FROM tips where TipDate = date(TipDate,'weekday 5') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Fri")
				y = NumberFormat2(GetDayTipAvg(Query), 0, 2, 2, True)
				
				BarChartBestTipDays.AddBarPointData(x, y)
			Case 6
				Query = "SELECT AVG(TipAmount) As 'TotalTips' FROM tips where TipDate = date(TipDate,'weekday 6') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Sat")
				y = NumberFormat2(GetDayTipAvg(Query), 0, 2, 2, True)
				
				BarChartBestTipDays.AddBarPointData(x, y)
			Case 7
				Query = "SELECT AVG(TipAmount) As 'TotalTips' FROM tips where TipDate = date(TipDate,'weekday 0') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Sun")
				y = NumberFormat2(GetDayTipAvg(Query), 0, 2, 2, True)
				
				BarChartBestTipDays.AddBarPointData(x, y)
		End Select
	Next
	
	BarChartBestTipDays.DrawChart
End Sub

Private Sub CreateStackedBarChartActualVsMin
		
	labelExplanation.Text = Main.Localize.Localize("This chart shows your actual earnings compared to the minimum wage for your current pay period and active Employer Profile.  Includes Delivery Fees.")
	
	'Create graph
	StackedBarChartActualVsMin.ClearData
	StackedBarChartActualVsMin.AddBar(Main.Localize.Localize("Minimum Gross"), xui.Color_Red)
	StackedBarChartActualVsMin.AddBar(Main.Localize.Localize("Actual Gross"), xui.Color_Blue)
	StackedBarChartActualVsMin.XScaleTextOrientation = "45 DEGREES"
	StackedBarChartActualVsMin.Title = Main.Localize.Localize("Actual Gross vs Minimum Gross")
	StackedBarChartActualVsMin.XAxisName = Main.Localize.Localize("Date")
	StackedBarChartActualVsMin.YAxisName = Main.Localize.Localize("Earnings")
	StackedBarChartActualVsMin.ChartType = "BAR"

	'Uses existing Employer Profile for calculaitons
	Dim PayPeriodStart As String
	Dim OffRoadWage As Double
	Dim OnRoadWage As Double
	Dim UseCashTips As String
	Dim nShiftTimeInSecs = 0 As Int
	Dim nDeliveryTimeInSecs = 0 As Int
	Dim MinGrossEarnings = 0 As Double
	Dim OnRoadEarnings = 0 As Double
	Dim OnRoadEarningsMustPay = 0 As Double
	Dim nTotalCashTips = 0 As Double
	Dim nTotalCreditTips = 0 As Double
	Dim nTotalTips = 0 As Double
	Dim nDeliveryFees = 0 As Double
	Dim MaxTipCredit = 0 As Double
	Dim ActualTipCredit = 0 As Double
	Dim ActualGrossEarnings = 0 As Double
	Dim Overtime = 0 As Double
	Dim TempDate As String
	Dim NoDays As Int
	Dim PayPeriod As String
	Dim EmployerProfile1 As List
	Dim lPayPeriod As List
		
	'Get Number of Days in Pay Period
	If PayPeriod = "Weeky" Then
		NoDays = 7
	Else
		NoDays = 14
	End If
	
	'Get Profile Record for hourly earnings and pay period
	EmployerProfile1 = GlobalFunctions.GetEmployerProfile(Main.ActiveEmployer)
	If EmployerProfile1.Size = 0 Then
		Return
	End If
	OffRoadWage = EmployerProfile1.Get(0)
	OnRoadWage = EmployerProfile1.Get(1)
	UseCashTips = EmployerProfile1.Get(2)
	PayPeriodStart = EmployerProfile1.Get(3)
	PayPeriod = EmployerProfile1.Get(4)

	'Find CURRENT PAY PERIOD based on Pay Week Ending date stored in Tip Credit Profile
	lPayPeriod.Initialize
	
	lPayPeriod = GetPayPeriod(PayPeriodStart, NoDays)
	TempDate = lPayPeriod.Get(0)  'Pay Period Start Date
	
	For i = 0 To NoDays
		PayPeriodStart = GlobalFunctions.GetNewDate(TempDate, i)
		nShiftTimeInSecs = 0
		Overtime = 0
		MinGrossEarnings = 0
		nDeliveryTimeInSecs = 0
		OnRoadEarnings = 0
		nTotalCashTips = 0
		nTotalCreditTips = 0
		MaxTipCredit = 0
		nTotalTips = 0
		ActualTipCredit = 0
		ActualGrossEarnings = 0
		
		'Get Total Hours worked in shop for period entered (SHIFT)
		'MIN WAGE x HOURS IN SHOP = MIN GROSS EARNINGS
		nShiftTimeInSecs = GlobalFunctions.GetShiftHoursWorked(Main.ActiveEmployer, PayPeriodStart, PayPeriodStart)
		If nShiftTimeInSecs = -1 Then
			Return
		End If

		'Calculate Overtime
		Overtime = GlobalFunctions.CalcOvertime(nShiftTimeInSecs, OffRoadWage, PayPeriod)
		
		'Calculate Minimum Earnings
		MinGrossEarnings = ((nShiftTimeInSecs/3600) * OffRoadWage) + Overtime

		'Get total hours worked on the road (DELIVERIES)
		'REDUCED WAGE x HOURS ON ROAD = ACTUAL EARNINGS BEFORE TIP CREDIT
		nDeliveryTimeInSecs = GlobalFunctions.GetRoadHoursWorked(Main.ActiveEmployer, PayPeriodStart, PayPeriodStart)
		If nDeliveryTimeInSecs = -1 Then
			Return
		End If
		
		OnRoadEarnings = (nDeliveryTimeInSecs/3600)* OnRoadWage
		OnRoadEarningsMustPay = (nDeliveryTimeInSecs/3600) * OffRoadWage
		
		'Get Total Tips for Period Entered
		'CASH TIPS
		nTotalCashTips = GlobalFunctions.GetTotalCashTips(Main.ActiveEmployer, PayPeriodStart, PayPeriodStart)
		
		'CREDIT TIPS
		nTotalCreditTips = GlobalFunctions.GetTotalCreditTips(Main.ActiveEmployer, PayPeriodStart, PayPeriodStart)
		
		'MIN WAGE - ROAD WAGE = MAX AMT EMPLOYER MAY TAKE AS A TIP CREDIT
'		MaxTipCredit = MinGrossEarnings - OnRoadEarnings   old code
		MaxTipCredit = OnRoadEarningsMustPay - OnRoadEarnings
		
		'Get Total Tips
		If UseCashTips = "True" Then
			nTotalTips = nTotalCashTips + nTotalCreditTips
		Else
			nTotalTips = nTotalCreditTips
		End If
		
		'ACTUAL TIP CREDIT = Minimum of MaxTipCredit and TotalTips
		ActualTipCredit = Min(nTotalTips, MaxTipCredit)
		
		'If Both wages are the same, then no tip credit
		If OffRoadWage = OnRoadWage Then
			ActualTipCredit = 0
		End If
		
		'IF ActualTipCredit is less than Total Tips Add Difference to MIN GROSS EARNINGS
		If ActualTipCredit <= nTotalTips Then
			If UseCashTips = "True" Then
				ActualGrossEarnings = MinGrossEarnings + (nTotalTips - ActualTipCredit)
			Else
				ActualGrossEarnings = MinGrossEarnings + (nTotalTips - ActualTipCredit) + nTotalCashTips
			End If
		Else
			ActualGrossEarnings = MinGrossEarnings 'GROSS EARNINGS CALC REMAINS AS IS
		End If
		
		PayPeriodStart = GlobalFunctions.ChangeDateFormat2(PayPeriodStart)
		
		'Get Delivery Fees
		nDeliveryFees = GlobalFunctions.GetTotalDeliveryFees(Main.ActiveEmployer, PayPeriodStart, PayPeriodStart)
		
		StackedBarChartActualVsMin.AddBarMultiplePoint(PayPeriodStart, Array As Double(MinGrossEarnings, ActualGrossEarnings + nDeliveryFees))
		
	Next
	
	StackedBarChartActualVsMin.DrawChart
End Sub

Private Sub CreatePieChartTipRetention
	'Tip Retention
	PieChartTipRetention.ClearData
	PieChartTipRetention.Title = Main.Localize.Localize("Retained Tips vs Tip Credits")
	
	labelExplanation.Text = Main.Localize.Localize("This chart shows what percentage of your tips that you are actually retaining (after taking into account the employer tip credit) for the current pay period and active Employer Profile.")
	
	'Uses existing Tip Credit Employer for calculaitons
	Dim PayPeriodStart, PayPeriodEnd As String
	Dim OffRoadWage As Double
	Dim OnRoadWage As Double
	Dim UseCashTips As String
	Dim nShiftTimeInSecs = 0 As Int
	Dim nDeliveryTimeInSecs = 0 As Int
	Dim MinGrossEarnings = 0 As Double
	Dim OnRoadEarnings = 0 As Double
	Dim OnRoadEarningsMustPay = 0 As Double
	Dim nTotalCashTips = 0 As Double
	Dim nTotalCreditTips = 0 As Double
	Dim nTotalTips = 0 As Double
	Dim MaxTipCredit = 0 As Double
	Dim ActualTipCredit = 0 As Double
	Dim ActualGrossEarnings = 0 As Double
	Dim Overtime = 0 As Double
	Dim NoDays As Int
	Dim PayPeriod As String
	Dim RetainedTips = 0 As Double
	Dim GrossTips = 0 As Double
	Dim EmployerProfile1 As List
	Dim lPayPeriod As List
	
	'Get Number of Days in Pay Period
	If PayPeriod = "Weeky" Then
		NoDays = 7
	Else
		NoDays = 14
	End If
	
	'Get Profile Record for hourly earnings
	EmployerProfile1 = GlobalFunctions.GetEmployerProfile(Main.ActiveEmployer)
	If EmployerProfile1.Size = 0 Then
		Return
	End If
	OffRoadWage = EmployerProfile1.Get(0)
	OnRoadWage = EmployerProfile1.Get(1)
	UseCashTips = EmployerProfile1.Get(2)
	PayPeriodStart = EmployerProfile1.Get(3)
	PayPeriod = EmployerProfile1.Get(4)

	'Find CURRENT PAY PERIOD based on Pay Week Ending date stored in Tip Credit Profile
	lPayPeriod.Initialize
	lPayPeriod = GetPayPeriod(PayPeriodStart, NoDays)
	
	PayPeriodStart = lPayPeriod.Get(0)  'Pay Period Start Date
	PayPeriodEnd = lPayPeriod.Get(1)  'Pay Period End Date
	
	'Get Total Hours worked in shop for period entered (SHIFT)
	'MIN WAGE x HOURS IN SHOP = MIN GROSS EARNINGS
	nShiftTimeInSecs = GlobalFunctions.GetShiftHoursWorked(Main.ActiveEmployer, PayPeriodStart, PayPeriodEnd)
	If nShiftTimeInSecs = -1 Then
		Return
	End If

	'Calculate Overtime
	Overtime = GlobalFunctions.CalcOvertime(nShiftTimeInSecs, OffRoadWage, PayPeriod)
	
	MinGrossEarnings = ((nShiftTimeInSecs/3600) * OffRoadWage) + Overtime

	'Get total hours worked on the road (DELIVERIES)
	'REDUCED WAGE x HOURS ON ROAD = ACTUAL EARNINGS BEFORE TIP CREDIT
	nDeliveryTimeInSecs = GlobalFunctions.GetRoadHoursWorked(Main.ActiveEmployer, PayPeriodStart, PayPeriodEnd)
	If nDeliveryTimeInSecs = -1 Then
		Return
	End If
	
	OnRoadEarnings = (nDeliveryTimeInSecs/3600)* OnRoadWage
	OnRoadEarningsMustPay = (nDeliveryTimeInSecs/3600) * OffRoadWage
	
	'Get Total Tips for Period Entered
	'CASH TIPS
	nTotalCashTips = GlobalFunctions.GetTotalCashTips(Main.ActiveEmployer, PayPeriodStart, PayPeriodEnd)
	
	'CREDIT TIPS
	nTotalCreditTips = GlobalFunctions.GetTotalCreditTips(Main.ActiveEmployer, PayPeriodStart, PayPeriodEnd)
	
	'MIN WAGE - ROAD WAGE = MAX AMT EMPLOYER MAY TAKE AS A TIP CREDIT
'	MaxTipCredit = MinGrossEarnings - OnRoadEarnings   old code
	MaxTipCredit = OnRoadEarningsMustPay - OnRoadEarnings
	
	'Get Total Tips
	If UseCashTips = "True" Then
		nTotalTips = nTotalCashTips + nTotalCreditTips
	Else
		nTotalTips = nTotalCreditTips
	End If
	
	'ACTUAL TIP CREDIT = Minimum of MaxTipCredit and TotalTips
	ActualTipCredit = Min(nTotalTips, MaxTipCredit)
	
	'If Both wages are the same, then no tip credit
	If OffRoadWage = OnRoadWage Then
		ActualTipCredit = 0
	End If
	
	'IF ActualTipCredit is less than Total Tips Add Difference to MIN GROSS EARNINGS
	If ActualTipCredit <= nTotalTips Then
		If UseCashTips = "True" Then
			ActualGrossEarnings = MinGrossEarnings + (nTotalTips - ActualTipCredit)
		Else
			ActualGrossEarnings = MinGrossEarnings + (nTotalTips - ActualTipCredit) + nTotalCashTips
		End If
	Else
		ActualGrossEarnings = MinGrossEarnings 'GROSS EARNINGS CALC REMAINS AS IS
	End If
	
	RetainedTips = ActualGrossEarnings - MinGrossEarnings
	GrossTips = nTotalCashTips + nTotalCreditTips

	PieChartTipRetention.AddPie(Main.Localize.Localize("Retained Tips"), (RetainedTips / GrossTips) * 360, xui.Color_Blue) '0 = random color
	PieChartTipRetention.AddPie(Main.Localize.Localize("Tip Credits"), 360 - ((RetainedTips / GrossTips) * 360), xui.Color_Red)
	
	PieChartTipRetention.DrawChart
End Sub

Private Sub CreateBarChartEarningsPerHour
	labelExplanation.Text = Main.Localize.Localize("This chart shows your per hour earnings (after the tip credit) for the current pay period and active Employer Profile.  Includes Delivery Fees.")
	
	'Create Bar
	BarChartEarningsPerHour.ClearData
	BarChartEarningsPerHour.Title = Main.Localize.Localize("Earnings Per Hour")
	BarChartEarningsPerHour.TitleTextColor = xui.Color_Black
	BarChartEarningsPerHour.AddBar(Main.Localize.Localize("$") & " " & Main.Localize.Localize("per Hour"), xui.Color_Blue)
	BarChartEarningsPerHour.XScaleTextOrientation = "45 DEGREES"
	BarChartEarningsPerHour.BarValueOrientation = "VERTICAL"
	BarChartEarningsPerHour.ScaleTextColor = xui.Color_Black
	BarChartEarningsPerHour.SetBarMeanValueFormat(1, 2, 2, False)
	BarChartEarningsPerHour.XAxisName = Main.Localize.Localize("Date")
	BarChartEarningsPerHour.YAxisName = Main.Localize.Localize("Earnings")
	
	'Uses existing Tip Credit Employer for calculaitons
	Dim PayPeriodStart As String
	Dim OffRoadWage As Double
	Dim OnRoadWage As Double
	Dim UseCashTips As String
	Dim nShiftTimeInSecs = 0 As Int
	Dim nDeliveryTimeInSecs = 0 As Int
	Dim MinGrossEarnings = 0 As Double
	Dim OnRoadEarnings = 0 As Double
	Dim OnRoadEarningsMustPay = 0 As Double
	Dim nTotalCashTips = 0 As Double
	Dim nTotalCreditTips = 0 As Double
	Dim nTotalTips = 0 As Double
	Dim nDeliveryFees = 0 As Double
	Dim MaxTipCredit = 0 As Double
	Dim ActualTipCredit = 0 As Double
	Dim ActualGrossEarnings = 0 As Double
	Dim Overtime = 0 As Double
	Dim TempDate As String
	Dim NoDays As Int
	Dim PayPeriod As String
	Dim EmployerProfile1 As List
	Dim lPayPeriod As List
	
	'Get Number of Days in Pay Period
	If PayPeriod = "Weeky" Then
		NoDays = 7
	Else
		NoDays = 14
	End If
	
	'Get Profile Record for hourly earnings
	EmployerProfile1 = GlobalFunctions.GetEmployerProfile(Main.ActiveEmployer)
	If EmployerProfile1.Size = 0 Then
		Return
	End If
	OffRoadWage = EmployerProfile1.Get(0)
	OnRoadWage = EmployerProfile1.Get(1)
	UseCashTips = EmployerProfile1.Get(2)
	PayPeriodStart = EmployerProfile1.Get(3)
	PayPeriod = EmployerProfile1.Get(4)

	'Find CURRENT PAY PERIOD based on Pay Week Ending date stored in Tip Credit Profile
	lPayPeriod.Initialize
	
	lPayPeriod = GetPayPeriod(PayPeriodStart, NoDays)
	TempDate = lPayPeriod.Get(0)  'Pay Period Start Date
	
	For i = 0 To NoDays
		PayPeriodStart = GlobalFunctions.GetNewDate(TempDate, i)
		nShiftTimeInSecs = 0
		Overtime = 0
		MinGrossEarnings = 0
		nDeliveryTimeInSecs = 0
		OnRoadEarnings = 0
		nTotalCashTips = 0
		nTotalCreditTips = 0
		MaxTipCredit = 0
		nTotalTips = 0
		ActualTipCredit = 0
		ActualGrossEarnings = 0
		
		'Get Total Hours worked in shop for period entered (SHIFT)
		'MIN WAGE x HOURS IN SHOP = MIN GROSS EARNINGS
		nShiftTimeInSecs = GlobalFunctions.GetShiftHoursWorked(Main.ActiveEmployer, PayPeriodStart, PayPeriodStart)
		If nShiftTimeInSecs = -1 Then
			Return
		End If

		'Calculate Overtime
		Overtime = GlobalFunctions.CalcOvertime(nShiftTimeInSecs, OffRoadWage, PayPeriod)
		
		MinGrossEarnings = ((nShiftTimeInSecs/3600) * OffRoadWage) + Overtime

		'Get total hours worked on the road (DELIVERIES)
		'REDUCED WAGE x HOURS ON ROAD = ACTUAL EARNINGS BEFORE TIP CREDIT
		nDeliveryTimeInSecs = GlobalFunctions.GetRoadHoursWorked(Main.ActiveEmployer, PayPeriodStart, PayPeriodStart)
		If nDeliveryTimeInSecs = -1 Then
			Return
		End If
		
		OnRoadEarnings = (nDeliveryTimeInSecs/3600)* OnRoadWage
		OnRoadEarningsMustPay = (nDeliveryTimeInSecs/3600) * OffRoadWage
		
		'Get Total Tips for Period Entered
		'CASH TIPS
		nTotalCashTips = GlobalFunctions.GetTotalCashTips(Main.ActiveEmployer, PayPeriodStart, PayPeriodStart)
		
		'CREDIT TIPS
		nTotalCreditTips = GlobalFunctions.GetTotalCreditTips(Main.ActiveEmployer, PayPeriodStart, PayPeriodStart)
		
		'MIN WAGE - ROAD WAGE = MAX AMT EMPLOYER MAY TAKE AS A TIP CREDIT
'		MaxTipCredit = MinGrossEarnings - OnRoadEarnings   old code
		MaxTipCredit = OnRoadEarningsMustPay - OnRoadEarnings
		
		'Get Total Tips
		If UseCashTips = "True" Then
			nTotalTips = nTotalCashTips + nTotalCreditTips
		Else
			nTotalTips = nTotalCreditTips
		End If
		
		'ACTUAL TIP CREDIT = Minimum of MaxTipCredit and TotalTips
		ActualTipCredit = Min(nTotalTips, MaxTipCredit)
		
		'If Both wages are the same, then no tip credit
		If OffRoadWage = OnRoadWage Then
			ActualTipCredit = 0
		End If
		
		'IF ActualTipCredit is less than Total Tips Add Difference to MIN GROSS EARNINGS
		If ActualTipCredit <= nTotalTips Then
			If UseCashTips = "True" Then
				ActualGrossEarnings = MinGrossEarnings + (nTotalTips - ActualTipCredit)
			Else
				ActualGrossEarnings = MinGrossEarnings + (nTotalTips - ActualTipCredit) + nTotalCashTips
			End If
		Else
			ActualGrossEarnings = MinGrossEarnings 'GROSS EARNINGS CALC REMAINS AS IS
		End If
		
		PayPeriodStart = GlobalFunctions.ChangeDateFormat2(PayPeriodStart)
				
		'Get Delivery Fee
		nDeliveryFees = GlobalFunctions.GetTotalDeliveryFees(Main.ActiveEmployer, PayPeriodStart, PayPeriodStart)
		
		If ActualGrossEarnings = 0 Or nShiftTimeInSecs = 0 Then
			BarChartEarningsPerHour.AddBarPointData(PayPeriodStart, 0)
		Else
			BarChartEarningsPerHour.AddBarPointData(PayPeriodStart, (ActualGrossEarnings + nDeliveryFees)/(nShiftTimeInSecs/3600))
		End If

	Next

	BarChartEarningsPerHour.DrawChart
End Sub

Private Sub CreatePieChartMileage
	'Employer Comparison Tips
	PieChartMileage.ClearData
	PieChartMileage.Title = Main.Localize.Localize("Employer Comparison Mileage")
	
	Dim ResultSet1 As ResultSet
	Dim Query1 As String
	Dim nTotalMiles As Double
	Dim cEmployer As String
	Dim nMilesRatio As Double
	Dim nEmployerMiles As Double

	labelExplanation.Text = Main.Localize.Localize("This chart shows the percentages of your total mileage from all the employers for whom you work.")

	'Get Total Miles
	ResultSet1 = Main.SQL1.ExecQuery("SELECT SUM(TripMiles) as 'TotalMiles' FROM tips")
	ResultSet1.NextRow
	nTotalMiles = ResultSet1.GetDouble("TotalMiles")
	
	'Get Total Tips from each Employer
	Query1 = "SELECT DISTINCT Employer FROM employers"
	ResultSet1 = Main.SQL1.ExecQuery(Query1)
	Do While ResultSet1.NextRow
		cEmployer = ResultSet1.GetString("Employer")
		
		nEmployerMiles = GlobalFunctions.GetTotalMiles(cEmployer, "2000-01-01", "2099-12-31")
		
		'Get Miles RRatio
		nMilesRatio = (nEmployerMiles / nTotalMiles) * 360
	
		'Create Pie slice
		PieChartMileage.AddPie(cEmployer, nMilesRatio, 0) '0 = random color
		
	Loop
	ResultSet1.Close
	
	PieChartMileage.DrawChart
	
End Sub

Private Sub CreateBarChartBestTipHours
	
	labelExplanation.Text = Main.Localize.Localize("This chart shows the average tip for each working hour of the day (10:00 AM to 1:00 AM) for the currently active Employer Profile.")
	
	'Create Bar Chart
	BarChartBestTipHours.ClearData
	BarChartBestTipHours.Title = Main.Localize.Localize("Best Tipping Hours")
	BarChartBestTipHours.TitleTextColor = xui.Color_Black
	BarChartBestTipHours.AddBar(Main.Localize.Localize("Avg Tip"), xui.Color_Blue)
	BarChartBestTipHours.XScaleTextOrientation = "45 DEGREES"
	BarChartBestTipHours.BarValueOrientation = "VERTICAL"
	BarChartBestTipHours.ScaleTextColor = xui.Color_Black
	BarChartBestTipHours.SetBarMeanValueFormat(1, 2, 2, False)
	BarChartBestTipHours.XAxisName = Main.Localize.Localize("Hour of Day")
	BarChartBestTipHours.YAxisName = Main.Localize.Localize("Tip Amount")
	
	Dim x As String
	Dim y As Double
	Dim Query As String
	
	Dim StartHour As String
	Dim EndHour As String
	Dim Designator As String
	
	'Fill Chart Data 10:00 am to midnight
	For i = 10 To 23
		StartHour = i & ":00:00"
		EndHour = i & ":59:59"
		
		Query = "SELECT AVG(TipAmount) As 'TotalTips' FROM tips WHERE DeliveryStartTime >= " & "'" & StartHour & "'" & _
		        " AND DeliveryStartTime <= " & "'" & EndHour & "'" & " AND employer = " & "'" & Main.ActiveEmployer & "'"
		If i = 10 Or i =11 Then
			Designator = "AM"
		Else
			Designator = "PM"
		End If
		
		If i > 12 Then
			x = (i-12) & ":00" & Designator
		Else
			x = i & ":00" & Designator
		End If
		y = NumberFormat2(GetDayTipAvg(Query), 0, 2, 2, True)
		
		BarChartBestTipHours.AddBarPointData(x, y)
	Next
	
	'Midnite to 2:00am
	For i = 0 To 1
		StartHour = i & ":00:00"
		EndHour = i & ":59:59"
		If i = 1 Then
			EndHour = "4:00:00"
		End If
		Query = "SELECT AVG(TipAmount) As 'TotalTips' FROM tips WHERE DeliveryStartTime >= " & "'" & StartHour & "'" & _
		        " AND DeliveryStartTime <= " & "'" & EndHour & "'" & " AND employer = " & "'" & Main.ActiveEmployer & "'"
		
		If i = 0 Then
			x = "12:00AM"
		Else
			x = "1:00AM+"
		End If
		y = NumberFormat2(GetDayTipAvg(Query), 0, 2, 2, True)
		
		BarChartBestTipHours.AddBarPointData(x, y)
	Next
	
	BarChartBestTipHours.DrawChart
End Sub

Private Sub CreateBarChartDeliveriesByHour
	
	labelExplanation.Text = Main.Localize.Localize("This chart shows the number of deliveries (aggregate) for each working hour of the day (10:00 AM to 1:00 AM) for the currently active Employer Profile.")
	
	'Create Bar Chart
	BarChartDeliveriesByHour.ClearData
	BarChartDeliveriesByHour.Title = Main.Localize.Localize("Deliveries by Hour")
	BarChartDeliveriesByHour.TitleTextColor = xui.Color_Black
	BarChartDeliveriesByHour.AddBar(Main.Localize.Localize("Deliveries"), xui.Color_Blue)
	BarChartDeliveriesByHour.XScaleTextOrientation = "45 DEGREES"
	BarChartDeliveriesByHour.BarValueOrientation = "VERTICAL"
	BarChartDeliveriesByHour.ScaleTextColor = xui.Color_Black
	BarChartDeliveriesByHour.SetBarMeanValueFormat(1, 2, 2, False)
	BarChartDeliveriesByHour.XAxisName = Main.Localize.Localize("Hour of Day")
	BarChartDeliveriesByHour.YAxisName = Main.Localize.Localize("Deliveries")
	
	Dim x As String
	Dim y As Double
	Dim Query As String
	
	Dim StartHour As String
	Dim EndHour As String
	Dim Designator As String
	
	'Fill Chart Data 10:00 am to midnight
	For i = 10 To 23
		StartHour = i & ":00:00"
		EndHour = i & ":59:59"
		
		Query = "SELECT COUNT(*) As 'Deliveries' FROM tips WHERE DeliveryStartTime >= " & "'" & StartHour & "'" & _
		        " AND DeliveryStartTime <= " & "'" & EndHour & "'" & " AND employer = " & "'" & Main.ActiveEmployer & "'"

		If i = 10 Or i =11 Then
			Designator = "AM"
		Else
			Designator = "PM"
		End If
		
		If i > 12 Then
			x = (i-12) & ":00" & Designator
		Else
			x = i & ":00" & Designator
		End If
		y = NumberFormat2(GetRecordCount(Query, 1), 0, 2, 2, False)
		
		BarChartDeliveriesByHour.AddBarPointData(x, y)
	Next
	
	'Midnite to 2:00am
	For i = 0 To 1
		StartHour = i & ":00:00"
		EndHour = i & ":59:59"
		If i = 1 Then
			EndHour = "04:00:00"
		End If
		Query = "SELECT COUNT(*) As 'Deliveries' FROM tips WHERE DeliveryStartTime >= " & "'" & StartHour & "'" & _
		        " AND DeliveryStartTime <= " & "'" & EndHour & "'" & " AND employer = " & "'" & Main.ActiveEmployer & "'"
		
		If i = 0 Then
			x = "12:00AM"
		Else
			x = "1:00AM+"
		End If
		y = NumberFormat2(GetRecordCount(Query, 1), 0, 2, 2, False)
		
		BarChartDeliveriesByHour.AddBarPointData(x, y)
	Next
	
	BarChartDeliveriesByHour.DrawChart
End Sub

Private Sub CreateBarChartDeliveriesByDay
	
	labelExplanation.Text = Main.Localize.Localize("This chart shows the number of deliveries (aggregate) for each day of the week for the currently active Employer Profile.")
	
	'Create Bar Chart
	BarChartDeliveriesByDay.ClearData
	BarChartDeliveriesByDay.Title = Main.Localize.Localize("Deliveries by Day")
	BarChartDeliveriesByDay.TitleTextColor = xui.Color_Black
	BarChartDeliveriesByDay.AddBar(Main.Localize.Localize("Deliveries"), xui.Color_Blue)
	BarChartDeliveriesByDay.XScaleTextOrientation = "45 DEGREES"
	BarChartDeliveriesByDay.BarValueOrientation = "VERTICAL"
	BarChartDeliveriesByDay.ScaleTextColor = xui.Color_Black
	BarChartDeliveriesByDay.SetBarMeanValueFormat(1, 2, 2, False)
	BarChartDeliveriesByDay.XAxisName = Main.Localize.Localize("Day of Week")
	BarChartDeliveriesByDay.YAxisName = Main.Localize.Localize("Deliveries")
	
	Dim x As String
	Dim y As Double
	Dim Query As String
	
	'Create Bars...Mon-Sun
	For i = 1 To 7
		Select i
			Case 1
				Query = "SELECT COUNT(*) As 'Deliveries' FROM tips where TipDate = date(TipDate,'weekday 1') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Mon")
				y = NumberFormat2(GetRecordCount(Query, 1), 0, 2, 2, False)
				
				BarChartDeliveriesByDay.AddBarPointData(x, y)
			Case 2
				Query = "SELECT COUNT(*) As 'Deliveries' FROM tips where TipDate = date(TipDate,'weekday 2') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Tue")
				y = NumberFormat2(GetRecordCount(Query, 1), 0, 2, 2, False)
				
				BarChartDeliveriesByDay.AddBarPointData(x, y)
			Case 3
				Query = "SELECT COUNT(*) As 'Deliveries' FROM tips where TipDate = date(TipDate,'weekday 3') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Wed")
				y = NumberFormat2(GetRecordCount(Query, 1), 0, 2, 2, False)
				
				BarChartDeliveriesByDay.AddBarPointData(x, y)
			Case 4
				Query = "SELECT COUNT(*) As 'Deliveries' FROM tips where TipDate = date(TipDate,'weekday 4') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Thu")
				y = NumberFormat2(GetRecordCount(Query, 1), 0, 2, 2, False)
				
				BarChartDeliveriesByDay.AddBarPointData(x, y)
			Case 5
				Query = "SELECT COUNT(*) As 'Deliveries' FROM tips where TipDate = date(TipDate,'weekday 5') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Fri")
				y = NumberFormat2(GetRecordCount(Query, 1), 0, 2, 2, False)
				
				BarChartDeliveriesByDay.AddBarPointData(x, y)
			Case 6
				Query = "SELECT COUNT(*) As 'Deliveries' FROM tips where TipDate = date(TipDate,'weekday 6') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Sat")
				y = NumberFormat2(GetRecordCount(Query, 1), 0, 2, 2, False)
				
				BarChartDeliveriesByDay.AddBarPointData(x, y)
			Case 7
				Query = "SELECT COUNT(*) As 'Deliveries' FROM tips where TipDate = date(TipDate,'weekday 0') AND employer = " & "'" & Main.ActiveEmployer & "'"
				
				x = Main.Localize.Localize("Sun")
				y = NumberFormat2(GetRecordCount(Query, 1), 0, 2, 2, False)
				
				BarChartDeliveriesByDay.AddBarPointData(x, y)
		End Select
	Next
	
	BarChartDeliveriesByDay.DrawChart
End Sub

Private Sub GetTotalAvgTips(pcBOM As String, pcEOM As String) As Double
	Dim ResultSetQ As ResultSet
	Dim nAvgTips As Double
	Dim Query As String
	
	Query = "SELECT AVG(TipAmount) AS 'AvgTips' FROM tips WHERE TipDate >= " & "'" & pcBOM & "' AND TipDate <= " & "'" & pcEOM & "'"
	
	ResultSetQ = Main.SQL1.ExecQuery(Query)
	ResultSetQ.NextRow

	If ResultSetQ.GetString("AvgTips") = Null Then
		nAvgTips = 0
	Else
		nAvgTips = ResultSetQ.GetDouble("AvgTips")
	End If

	ResultSetQ.Close
	
	Return nAvgTips
End Sub

Private Sub GetTipRatios
	Dim nCashTips As Double
	Dim nTotalTips As Double
	
	nCashTips = GlobalFunctions.GetTotalCashTips(Main.Localize.Localize("All"), "2000-01-01", "2099-12-31")
	
	nTotalTips = GlobalFunctions.GetTotalTips(Main.Localize.Localize("All"), "2000-01-01", "2099-12-31")
	
	'Get Cash Tip Ratio
	nCashTipRatio =  (nCashTips / nTotalTips) * 360

	'Get Credit Tip Ratio
	nCreditTipRatio = 360 - nCashTipRatio
	
End Sub

Private Sub GetPayPeriod(pStartDate As String, pNoDays As Int) As List
	Dim PayPeriodStart As String
	Dim PayPeriodEnd As String
	DateTime.DateFormat = "yyyy-MM-dd"
	Dim tStart As Long
	Dim tEnd As Long
	Dim tTemp As Long
	Dim t As Long
	Dim tToday As Long
	Dim strToday As String
	
	Dim PayPeriodDates As List
	PayPeriodDates.Initialize
	
	t = DateTime.DateParse(pStartDate)	'Get ticks value of passed date
	tStart = DateTime.Add(t, 0, 0, 1)   'adding one day since profile asks for last date of a real pay period
	tTemp = tStart
	tToday = DateTime.Now
	strToday = DateTime.Date(tToday)
	tToday = DateTime.DateParse(strToday)

	Dim Counter = 0 As Int
	Do While True
		'Create a "moving" pay period
		tStart = DateTime.Add(tTemp, 0, 0 , Counter) 'beginning of pay period
		tEnd = DateTime.Add(tStart, 0, 0, pNoDays-1) 'end of pay period
		'See if today is within pay period
		If tToday >= tStart And tToday <= tEnd Then
			Exit  'I have the pay period I need
		End If
		Counter = Counter + pNoDays
	Loop
	
	PayPeriodStart = DateTime.Date(tStart)
	PayPeriodEnd = DateTime.Date(tEnd)
	
	PayPeriodDates.Add(PayPeriodStart)
	PayPeriodDates.Add(PayPeriodEnd)
	
	Return PayPeriodDates
End Sub

Private Sub PageChartsAndGraphs_Disappear
	Main.NavControl.SetPagesStack(Array (Mainscreen.PageMain))
	SelectedChart = 1
	Mainscreen.CloseMenu
End Sub

Private Sub GetDayTipAvg(pQuery As String) As Double
	Dim ResultSet1 As ResultSet
	Dim ReturnVal = 0 As Double
	
	ResultSet1 = Main.SQL1.ExecQuery(pQuery)
	ResultSet1.NextRow
	If ResultSet1.GetString("TotalTips") <> Null Then
		ReturnVal = ResultSet1.GetDouble("TotalTips")
	End If
	
	ResultSet1.Close
	
	Return ReturnVal
End Sub

Private Sub GetRecordCount(pQuery As String, pDivisor As Int) As Double
	Dim ResultSet1 As ResultSet
	Dim ReturnVal As String
	Dim nRetVal = 0 As Double
	
	ResultSet1 = Main.SQL1.ExecQuery(pQuery)
	ResultSet1.NextRow
	If ResultSet1.GetString("Deliveries") <> Null Then
		ReturnVal = ResultSet1.GetString("Deliveries")
	End If
	
	ResultSet1.Close
	
	nRetVal = ReturnVal / pDivisor

	Return nRetVal
End Sub

Private Sub ShowChart(pChart As Int)

	'Hide all charts except the next one
	PieChartEmployers.Visible = False
	PieChart2Employers.Visible = False
	PieChartCashCredit.Visible = False
	LineChartAvgTips.Visible = False
	BarChartBestTipDays.Visible = False
	StackedBarChartActualVsMin.Visible = False
	BarChartEarningsPerHour.Visible = False
	PieChartTipRetention.Visible = False
	PieChartMileage.Visible = False
	BarChartBestTipHours.Visible = False
	BarChartDeliveriesByHour.Visible = False
	BarChartDeliveriesByDay .Visible = False

	Select pChart
		Case 1
			btnPrevious.Visible = False
			btnNext.Visible = True
			PieChartEmployers.Visible = True
			CreatePieDataEmployers
		Case 2
			btnPrevious.Visible = True
			PieChart2Employers.Visible = True
			CreatePieData2Employers
		Case 3
			PieChartCashCredit.Visible = True
			CreatePieDataCashCredit
		Case 4
			LineChartAvgTips.Visible = True
			CreateLineChartAvgTips
		Case 5
			BarChartBestTipDays.Visible = True
			CreateBarChartBestTipDays
		Case 6
			StackedBarChartActualVsMin.Visible = True
			CreateStackedBarChartActualVsMin
		Case 7
			BarChartEarningsPerHour.Visible = True
			CreateBarChartEarningsPerHour
		Case 8
			PieChartTipRetention.Visible = True
			CreatePieChartTipRetention
		Case 9
			PieChartMileage.Visible = True
			CreatePieChartMileage
		Case 10
			BarChartBestTipHours.Visible = True
			CreateBarChartBestTipHours
		Case 11
			btnNext.Visible = True
			BarChartDeliveriesByHour.Visible = True
			CreateBarChartDeliveriesByHour
		Case 12
			btnPrevious.Visible = True
			btnNext.Visible = False
			BarChartDeliveriesByDay.Visible = True
			CreateBarChartDeliveriesByDay
	End Select
End Sub

Private Sub ResetLayout
PageChartsAndGraphs.RootPanel.RemoveAllViews
PageChartsAndGraphs.RootPanel.LoadLayout("MultiCharts")
PageChartsAndGraphs.Title = Main.Localize.Localize("Charts and Graphs")  'List(PageTitle).Get(0)
Main.Localize.LocalizeLayout(PageChartsAndGraphs.RootPanel)
End Sub
