﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.8
@EndOfDesignText@
''Code module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.

	Public TimeFormatState As String

End Sub

Sub SetGradient(v As View, color1 As Int, color2 As Int, Replace As Boolean)
	Dim NaObj As NativeObject = Me
	NaObj.RunMethod("SetGradient::::",Array(v,NaObj.ColorToUIColor(color1),NaObj.ColorToUIColor(color2), Replace))
End Sub

#If OBJC
- (void)SetGradient: (UIView*) View :(UIColor*) Color1 :(UIColor*) Color2 :(BOOL)replace{
   CAGradientLayer *gradient = [CAGradientLayer layer];
   gradient.colors = [NSArray arrayWithObjects:(id)Color1.CGColor, (id)Color2.CGColor, nil];
   gradient.frame = View.bounds;
   if (replace)
     [View.layer replaceSublayer:View.layer.sublayers[0] with:gradient];
   else
     [View.layer insertSublayer:gradient atIndex:0];
}
#end if

Public Sub SetTheme(pPanel As Panel, lReplace As Boolean)
	'Sets panel's gradient color scheme
	SetGradient(pPanel, _
	Colors.ARGB(Main.ThemeTopColorAlpha, Main.ThemeTopColorRed, Main.ThemeTopColorGreen, Main.ThemeTopColorBlue), _
	Colors.ARGB(Main.ThemeBottomColorAlpha, Main.ThemeBottomColorRed, Main.ThemeBottomColorGreen, Main.ThemeBottomColorBlue), lReplace)
End Sub

Public Sub TodaysSQLDate As String
	'Change Date format to yyyy-mm-dd for sql accepted format..today's date
	
	Dim t As Long
	Dim cDate As String
	Dim strDate As String
	
	DateTime.DateFormat = "MM-dd-yyyy"
	strDate = DateTime.Date(DateTime.Now)
	t = DateTime.DateParse(strDate)
	DateTime.DateFormat = "yyyy-MM-dd"
	cDate = DateTime.Date(t)
	
	Return cDate
End Sub

Public Sub ChangeDateFormat2(cDate As String) As String
	'Change Date format to MM-dd-yyyy
	Dim t As Long
	Dim strDate As String
	
	DateTime.DateFormat = "yyyy-MM-dd"
	t = DateTime.DateParse(cDate)
	DateTime.DateFormat = "MM-dd-yyyy"
	strDate = DateTime.Date(t)
	
	Return strDate
End Sub

Public Sub GetSecondsofTime(timeString As String) As Int
	Dim strArray() As String = Regex.Split(":", timeString)
	Return strArray(0) * 3600 + strArray(1) * 60 + strArray(2)
End Sub

Public Sub GetNewDate(pDate As String, pDays As Int) As String
	'Returns date that is pDays +/- from pDate
	DateTime.DateFormat = "yyyy-MM-dd"
	Dim tDate As Long
	Dim tNewDate As Long
	Dim strNewDate As String
	
	tDate= DateTime.DateParse(pDate)
	tNewDate = DateTime.Add(tDate, 0, 0 , pDays)
	strNewDate = DateTime.Date(tNewDate)
	
	Return strNewDate
End Sub

Public Sub TimeBetweenTwoDates(D1 As String, T1 As String, D2 As String, T2 As String) As String
	Dim start, endTime, t As Long
	Try
		start = DateTime.DateTimeParse(D1, T1)
		endTime = DateTime.DateTimeParse(D2, T2)
'		Dim days As Int 
		Dim hours, minutes, seconds As Int
		t = Abs(endTime - start)
'		days = Floor(t / DateTime.TicksPerDay)
		hours = Floor((t Mod DateTime.TicksPerDay) / DateTime.TicksPerHour)
		minutes = Floor((t Mod DateTime.TicksPerHour) / DateTime.TicksPerMinute)
		seconds = Floor((t Mod DateTime.TicksPerMinute) / DateTime.TicksPerSecond)
		Return hours & ":" & minutes & ":" & seconds
	Catch
		Log(LastException)
		Return "00:00:00"
	End Try
    
'	Log("Days = " & days)
'	Log("Hours = " & hours)
'	Log("Minutes = " & minutes)
'	Log("Seconds = " & seconds)
'	Msgbox("Days = " & days & CRLF & "Hours = " & hours & CRLF & "Minutes = " & minutes & CRLF & "Seconds = " & seconds, "OK")
End Sub

Public Sub ShowAmPmTime(pTime As String, lShowAmPm As Boolean) As String
	'Return formatted am pm time
	Dim strTime As List
	Dim NewTime As String
	Dim Hours As Int
	Dim Minutes As Int
	Dim Seconds As Int
	Dim strAmPm As String
	Dim strMinutes As String
	Dim strSeconds As String
	
	strTime = Regex.Split(":", pTime)
	
	'Get Hour
	Try
		Hours = strTime.Get(0)
	Catch
		Hours = "00"
	End Try
	Try
		Minutes = strTime.Get(1)
	Catch
		Minutes = "00"
	End Try
	Try
		Seconds = strTime.Get(2)
	Catch
		Seconds = "00"
	End Try
		
	Select Hours
		Case 0
			If lShowAmPm = True Then
				Hours = 12
			End If
			strAmPm = "am"
		Case 12
			strAmPm = "pm"
		Case 13,14,15,16,17,18,19,20,21,22,23
			Hours = Hours - 12
			strAmPm = "pm"
		Case Else
			strAmPm = "am"
	End Select

	Select Minutes
		Case 0,1,2,3,4,5,6,7,8,9
			strMinutes = "0" & Minutes
		Case Else
			strMinutes = Minutes
	End Select
	
	Select Seconds
		Case 0,1,2,3,4,5,6,7,8,9
			strSeconds = "0" & Seconds
		Case Else
			strSeconds = Seconds
	End Select
	
	If lShowAmPm = True Then
		NewTime = Hours & ":" & strMinutes & ":" & strSeconds & " " & strAmPm
	Else
		NewTime = Hours & ":" & strMinutes & ":" & strSeconds
	End If
	
	Return NewTime
End Sub

Public Sub Get24HourTime(pTime As String) As String
	'Converts am/pm times to 24 hour format for saving in sql database
	Dim strTime As String
	Dim TimeList As List
	Dim nHours As Int
	Dim Hours As String
	Dim Minutes As String
	Dim Seconds As String
	Dim Designator As String
	Dim l As Int
	
	strTime = pTime.ToLowerCase
	
	'Don't allow "12:00:00am"
	If strTime = "12:00:00 am" Then
		Return "00:00:00"
	End If
	
	TimeList = Regex.Split(":", strTime)
	nHours = TimeList.Get(0)
	Hours = TimeList.Get(0)
	Hours = Hours.Trim
	Minutes = TimeList.Get(1)
	Minutes = Minutes.trim
	Seconds = TimeList.Get(2)
	Seconds = Seconds.Trim
	
	'Isolate Designator
	l = Seconds.Length
	Designator = Seconds.SubString2(l-2, l)
	Designator = Designator.Trim
	Seconds = Seconds.SubString2(0, l-2)
	Seconds = Seconds.Trim
	
	Select Designator
		Case "am"
			If nHours = 12 Then
				nHours = 0'
				Hours = "0"
			End If
		Case "pm"
			If nHours < 12 Then
				nHours = nHours + 12
				Hours = nHours
			End If
	End Select
	
	strTime = Hours & ":" & Minutes & ":" & Seconds
	
	Return strTime
End Sub

Public Sub ToastMessage(pText As String, pLongShow As Boolean)
	Dim hd As HUD
	
	hd.ProgressDialogShow(Main.Localize.Localize(pText))
	If pLongShow = False Then
		Wait For(WaitAFewSecs(1000)) Complete (Result As Boolean)
	Else
		Wait For(WaitAFewSecs(2000)) Complete (Result As Boolean)
	End If
	hd.ProgressDialogHide
End Sub

Public Sub WaitAFewSecs(pSecs As Int) As ResumableSub
	Sleep(pSecs)
	Return True
End Sub

Public Sub RemoveFontInfoFromString(pString As String) As String
	'Removes "{....}" from Picker fields that have REDUCED size
	Dim str As String
	Dim idx As Int
	str = pString
	idx = str.IndexOf("{")
	Return str.SubString2(0, idx)
End Sub

Public Sub GetDigitMonthofYear(cMonth As String) As String
	'Return 2 character number of month based on my month spinners
	Dim locMonth As String
	locMonth = Main.Localize.Localize(cMonth)
	
	Select locMonth
		Case "JAN"
			cMonth = "01"
		Case "FEB"
			cMonth = "02"
		Case "MAR"
			cMonth = "03"
		Case "APR"
			cMonth = "04"
		Case "MAY"
			cMonth = "05"
		Case "JUN"
			cMonth = "06"
		Case "JUL"
			cMonth = "07"
		Case "AUG"
			cMonth = "08"
		Case "SEP"
			cMonth = "09"
		Case "OCT"
			cMonth = "10"
		Case "NOV"
			cMonth = "11"
		Case "DEC"
			cMonth = "12"
	End Select
	
	Return cMonth
End Sub

Public Sub FormatNumberToDecimal(pNumber As String) As String
	'used to add a decimal and trailing zeros as needed when an entry has no decimal or only 1 digit after decimal point
	Dim strTip As String
	Dim strTipTest As String
	Dim nPeriodPosition = -1 As Int
	
	'Remove Dollar sign, if present
	Do While True
		If pNumber.Contains(Main.Localize.Localize("$")) = True Then
			pNumber = pNumber.SubString(1)
			Log(pNumber)
		Else
			Exit
		End If
	Loop
	
	strTip = pNumber
	
	'Add zeros to end of non decimal entry
	If strTip.Contains(".") = False Then
		strTip = strTip & ".00"
		pNumber = strTip
		Return pNumber
	End If
	
	'Add additional trailing zero, if needed.  Period exists at this point
	nPeriodPosition = strTip.IndexOf(".")
	strTipTest = strTip.SubString(nPeriodPosition)
	If strTipTest.Length = 1 Then  'Period and no number
		strTip = strTip & "00"
		pNumber = strTip
		Return pNumber
	End If
	If strTipTest.Length = 2 Then  'Period and one number
		strTip = strTip & "0"
		pNumber = strTip
		Return pNumber
	End If
	
	Return pNumber
End Sub

Public Sub GetEmployerList(pSelection As String, pShowAll As Boolean) As List
	'Return list of Employers for spinner
	Dim Query1 As String
	Dim ResultSet1 As ResultSet
	Dim EmployerList As List
	Dim cs As CSBuilder
	Dim fnt As Font = Font.CreateNew(17)
	Dim nCounter = -1 As Int
	Dim pEmployer As String
	
	EmployerList.Initialize
	
	'If parameter is passed, want that Employer to be displayed in spinner
	If pSelection = "Default" Then
		pEmployer = Main.ActiveEmployer
	Else
		pEmployer = pSelection
	End If
		
	'Add "All" to list
	If pShowAll = True Then
		EmployerList.Add(cs.Initialize.Font(fnt).Append(Main.Localize.Localize("All")).PopAll)
	End If
	
	Query1 = "SELECT DISTINCT Employer FROM employers ORDER BY Employer ASC"
	ResultSet1 = Main.SQL1.ExecQuery(Query1)
	Do While ResultSet1.NextRow
		nCounter = nCounter +1
		If ResultSet1.GetString("Employer") = pEmployer Then
			Main.EmployerIndex = nCounter
		End If
		EmployerList.Add(cs.Initialize.Font(fnt).Append(ResultSet1.GetString("Employer")).PopAll)
	Loop
		
	ResultSet1.Close
	
	Return EmployerList
End Sub

Public Sub GetSpinnerMonths As List
	Dim DateMonth As List
	DateMonth.Initialize
	Dim cs As CSBuilder
	Dim fnt As Font = Font.CreateNew(14)
	
	For i = 1 To 4
		DateMonth.Add(cs.Initialize.Font(fnt).Append(Main.Localize.Localize("JAN")))
		DateMonth.Add(cs.Initialize.Font(fnt).Append(Main.Localize.Localize("FEB")))
		DateMonth.Add(cs.Initialize.Font(fnt).Append(Main.Localize.Localize("MAR")))
		DateMonth.Add(cs.Initialize.Font(fnt).Append(Main.Localize.Localize("APR")))
		DateMonth.Add(cs.Initialize.Font(fnt).Append(Main.Localize.Localize("MAY")))
		DateMonth.Add(cs.Initialize.Font(fnt).Append(Main.Localize.Localize("JUN")))
		DateMonth.Add(cs.Initialize.Font(fnt).Append(Main.Localize.Localize("JUL")))
		DateMonth.Add(cs.Initialize.Font(fnt).Append(Main.Localize.Localize("AUG")))
		DateMonth.Add(cs.Initialize.Font(fnt).Append(Main.Localize.Localize("SEP")))
		DateMonth.Add(cs.Initialize.Font(fnt).Append(Main.Localize.Localize("OCT")))
		DateMonth.Add(cs.Initialize.Font(fnt).Append(Main.Localize.Localize("NOV")))
		DateMonth.Add(cs.Initialize.Font(fnt).Append(Main.Localize.Localize("DEC")))
	Next
	
	Return DateMonth
End Sub

Public Sub GetSpinnerDays As List
	Dim dateDay As List
	dateDay.Initialize
	Dim cs As CSBuilder
	Dim fnt As Font = Font.CreateNew(14)
	
	For x = 1 To 4
		For i = 1 To 31
			dateDay.Add(cs.Initialize.Font(fnt).Append(i))
		Next
	Next
	
	Return dateDay
End Sub

Public Sub GetSpinnerYears As List
	Dim dateYear As List
	Dim cs As CSBuilder
	Dim fnt As Font = Font.CreateNew(14)
	
	dateYear.Initialize
	
	For x = 1 To 4
		For i = 2000 To 2099
			dateYear.Add(cs.Initialize.Font(fnt).Append(i))
		Next
	Next
	
	Return dateYear
End Sub

Public Sub ShowOperators As List
	'Used in Filter Module
	Dim Operators As List
	Operators.Initialize
	
	Operators.Add("=")
	Operators.Add(">=")
	Operators.Add("<=")
	
	Return Operators
	
End Sub

Public Sub GetTotalCreditTips(pEmployer As String, pStartPeriod As String, pEndPeriod As String) As Double
	Dim Query1 As String
	Dim ResultSet1 As ResultSet
	Dim TotalCreditTips As Double
	
	If pEmployer <> Main.Localize.Localize("All") Then
		Query1 = "SELECT SUM(TipAmount) As 'TotalCreditTips' FROM tips WHERE Employer = " & "'" & pEmployer & "'" & " AND TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "'" & " AND TipType = 'Credit'"
	Else
		Query1 = "SELECT SUM(TipAmount) As 'TotalCreditTips' FROM tips WHERE TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "'" & " AND TipType = 'Credit'"
	End If
				 			 
	ResultSet1 = Main.SQL1.ExecQuery(Query1)
	ResultSet1.NextRow
	If ResultSet1.GetString("TotalCreditTips") = Null Then
		TotalCreditTips = 0
	Else
		TotalCreditTips = ResultSet1.GetDouble("TotalCreditTips")
	End If
	
	ResultSet1.Close
	
	Return TotalCreditTips
End Sub

Public Sub GetTotalCashTips(pEmployer As String, pStartPeriod As String, pEndPeriod As String) As Double
	Dim Query1 As String
	Dim ResultSet1 As ResultSet
	Dim TotalCashTips As Double

	If pEmployer <> Main.Localize.Localize("All") Then
		Query1 = "SELECT SUM(TipAmount) As 'TotalCashTips' FROM tips WHERE Employer = " & "'" & pEmployer & "'" & " AND TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "'" & " AND (TipType = 'Cash' OR TipType = 'No Tip')"
	Else
		Query1 = "SELECT SUM(TipAmount) As 'TotalCashTips' FROM tips WHERE TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "'" & " AND (TipType = 'Cash' OR TipType = 'No Tip')"
	End If
				 			 
	ResultSet1 = Main.SQL1.ExecQuery(Query1)
	ResultSet1.NextRow
	If ResultSet1.GetString("TotalCashTips") = Null Then
		TotalCashTips = 0
	Else
		TotalCashTips = ResultSet1.GetDouble("TotalCashTips")
	End If
	
	ResultSet1.Close
	
	Return TotalCashTips
End Sub

Public Sub GetTotalTips(pEmployer As String, pStartPeriod As String, pEndPeriod As String) As Double
	Dim Query1 As String
	Dim ResultSet1 As ResultSet
	Dim TotalTips As Double

	If pEmployer <> Main.Localize.Localize("All") Then
		Query1 = "SELECT SUM(TipAmount) As 'TotalTips' FROM tips WHERE Employer = " & "'" & pEmployer & "'" & " AND TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "'" 
	Else
		Query1 = "SELECT SUM(TipAmount) As 'TotalTips' FROM tips WHERE TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "'"
	End If
				 			 
	ResultSet1 = Main.SQL1.ExecQuery(Query1)
	ResultSet1.NextRow
	If ResultSet1.GetString("TotalTips") = Null Then
		TotalTips = 0
	Else
		TotalTips = ResultSet1.GetDouble("TotalTips")
	End If
	
	ResultSet1.Close
	
	Return TotalTips
End Sub

Public Sub GetTotalDeliveries(pEmployer As String, pStartPeriod As String, pEndPeriod As String) As Int
	Dim Query1 As String
	Dim ResultSet1 As ResultSet
	Dim TotalDeliveries As Int

	If pEmployer <> Main.Localize.Localize("All") Then
		Query1 = "SELECT COUNT(TipAmount) As 'Deliveries' FROM tips WHERE Employer = " & "'" & pEmployer & "'" & " AND TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "'" 
	Else
		Query1 = "SELECT COUNT(TipAmount) As 'Deliveries' FROM tips WHERE TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "'"
	End If
				 			 
	ResultSet1 = Main.SQL1.ExecQuery(Query1)
	ResultSet1.NextRow
	If ResultSet1.GetString("Deliveries") = Null Then
		TotalDeliveries = 0
	Else
		TotalDeliveries = ResultSet1.GetInt("Deliveries")
	End If
	
	ResultSet1.Close

	Return TotalDeliveries
End Sub

Public Sub GetNumberOfTips(pEmployer As String, pStartPeriod As String, pEndPeriod As String) As Int
	Dim Query1 As String
	Dim ResultSet1 As ResultSet
	Dim NumberOfTips As Int

	If pEmployer <> Main.Localize.Localize("All") Then
		Query1 = "SELECT COUNT(TipAmount) As 'NumberOfTips' FROM tips WHERE Employer = " & "'" & pEmployer & "'" & " AND TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "' AND TipAmount > 0 AND TipType <> 'No Tip'" 
	Else
		Query1 = "SELECT COUNT(TipAmount) As 'NumberOfTips' FROM tips WHERE TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "' AND TipAmount > 0 AND TipType <> 'No Tip'"
	End If
				 			 
	ResultSet1 = Main.SQL1.ExecQuery(Query1)
	ResultSet1.NextRow
	If ResultSet1.GetString("NumberOfTips") = Null Then
		NumberOfTips = 0
	Else
		NumberOfTips = ResultSet1.GetInt("NumberOfTips")
	End If
	
	ResultSet1.Close
	
	Return NumberOfTips
End Sub

Public Sub GetNumberOfStiffs(pEmployer As String, pStartPeriod As String, pEndPeriod As String) As Int
	Dim Query1 As String
	Dim ResultSet1 As ResultSet
	Dim NumberOfStiffs As Int

	If pEmployer <> Main.Localize.Localize("All") Then
		Query1 = "SELECT COUNT(TipAmount) As 'NumberOfStiffs' FROM tips WHERE Employer = " & "'" & pEmployer & "'" & " AND TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "' AND TipType = 'No Tip'" 
	Else
		Query1 = "SELECT COUNT(TipAmount) As 'NumberOfStiffs' FROM tips WHERE TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "' AND TipType = 'No Tip'"
	End If
				 			 
	ResultSet1 = Main.SQL1.ExecQuery(Query1)
	ResultSet1.NextRow
	If ResultSet1.GetString("NumberOfStiffs") = Null Then
		NumberOfStiffs = 0
	Else
		NumberOfStiffs = ResultSet1.GetInt("NumberOfStiffs")

	End If
	
	ResultSet1.Close
	
	Return NumberOfStiffs
End Sub

Public Sub GetShiftHoursWorked(pEmployer As String, pStartDate As String, pEndDate As String) As Int
	Dim Query1 As String
	Dim ResultSet1 As ResultSet
	Dim nShiftTimeInSecs = 0 As Int
	
	'Get Total Hours worked in shop for period entered (SHIFT)
	'MIN WAGE x HOURS IN SHOP = MIN GROSS EARNINGS
	Query1 = "SELECT ShiftLength FROM shifts WHERE Employer = " & "'" & pEmployer & "'" & " AND ShiftDate >= " & "'" & pStartDate & "'" & _
	         " AND ShiftDate <= " & "'" & pEndDate & "'"
	ResultSet1 = Main.SQL1.ExecQuery(Query1)
	Do While ResultSet1.NextRow
		If ResultSet1.GetString("ShiftLength") = Null Then
'			DialogBox("Action Needed", "Missing Shift Records.", "OK", "", "")
			Return -1
		End If
		nShiftTimeInSecs = nShiftTimeInSecs + GetSecondsofTime(ResultSet1.GetString("ShiftLength"))
	Loop
	
	ResultSet1.Close
	
	Return nShiftTimeInSecs
End Sub

Public Sub GetRoadHoursWorked(pEmployer As String, pStartDate As String, pEndDate As String) As Int
	'Get total hours worked on the road (DELIVERIES)
	'REDUCED WAGE x HOURS ON ROAD = ACTUAL EARNINGS BEFORE TIP CREDIT
	Dim Query1 As String
	Dim ResultSet1 As ResultSet
	Dim nDeliveryTimeInSecs = 0 As Int
	
	Query1 = "SELECT DeliveryLength FROM tips WHERE Employer = " & "'" & pEmployer & "'" & " AND TipDate >= " & "'" & pStartDate & "'" & _
	         " AND TipDate <= " & "'" & pEndDate & "'"
	ResultSet1 = Main.SQL1.ExecQuery(Query1)
	Do While ResultSet1.NextRow
		If ResultSet1.GetString("DeliveryLength") = Null Then
'			DialogBox("Action Needed", "Missing Delivery Time Records.", "OK", "", "")
			Return -1
		End If
		nDeliveryTimeInSecs = nDeliveryTimeInSecs + GetSecondsofTime(ResultSet1.GetString("DeliveryLength"))
	Loop
	
	ResultSet1.Close
	
	Return nDeliveryTimeInSecs
End Sub

Public Sub CalcOvertime(pSecs As Int, pWage As Double, pPayPeriod As String) As Double
	'Calculate Overtime up to 60 hours per week
	Dim OTSecs = 0 As Int
	Dim OT = 0 As Double
	
	If pPayPeriod = "Weekly" Or pPayPeriod = "Semanal" Then
		If pSecs > 144000 And pSecs <= 216000 Then   '144000 secs = 40 hours  up to 60 hours...insane
			OTSecs = pSecs - 144000
			OT = ((OTSecs/3600) * pWage * 1.50)
		End If
	Else
		If pSecs > 288000 And pSecs <= 432000 Then   '288000 secs = 80 hours  up to 120 hours.. insane
			OTSecs = pSecs - 288000
			OT = ((OTSecs/3600) * pWage * 1.50)
		End If
	End If
	
	Return OT
	
End Sub

Public Sub GetAvgCreditTips(pEmployer As String, pStartPeriod As String, pEndPeriod As String) As Double
	Dim ResultSetQ As ResultSet
	Dim nAvgCreditTips As Double
	Dim Query As String
	
	If pEmployer <> Main.Localize.Localize("All") Then
		Query = "SELECT AVG(TipAmount) AS 'AvgCreditTips' FROM tips WHERE Employer = " & "'" & pEmployer & "'" & " AND TipDate >= " & "'" & pStartPeriod & "'" & _
			         " AND TipDate <= " & "'" & pEndPeriod & "' AND TipType = 'Credit'"
	Else
		Query = "SELECT AVG(TipAmount) AS 'AvgCreditTips' FROM tips WHERE TipDate >= " & "'" & pStartPeriod & "'" & _
			         " AND TipDate <= " & "'" & pEndPeriod & "' AND TipType = 'Credit'"
	End If
	
	ResultSetQ = Main.SQL1.ExecQuery(Query)
	ResultSetQ.NextRow

	If ResultSetQ.GetString("AvgCreditTips") = Null Then
		nAvgCreditTips = 0
	Else
		nAvgCreditTips = ResultSetQ.GetDouble("AvgCreditTips")
	End If

	ResultSetQ.Close
	
	Return nAvgCreditTips
End Sub

Public Sub GetAvgCashTips(pEmployer As String, pStartPeriod As String, pEndPeriod As String) As Double
	Dim ResultSetQ As ResultSet
	Dim nAvgCashTips As Double
	Dim Query As String
	
	If pEmployer <> Main.Localize.Localize("All") Then
		Query = "SELECT AVG(TipAmount) AS 'AvgCashTips' FROM tips WHERE Employer = " & "'" & pEmployer & "'" & " AND TipDate >= " & "'" & pStartPeriod & "'" & _
			         " AND TipDate <= " & "'" & pEndPeriod & "' AND TipType <> 'Credit' AND TipAmount > 0"
	Else
		Query = "SELECT AVG(TipAmount) AS 'AvgCashTips' FROM tips WHERE TipDate >= " & "'" & pStartPeriod & "'" & _
			         " AND TipDate <= " & "'" & pEndPeriod & "' AND TipType <> 'Credit' AND TipAmount > 0"
	End If
					 
	ResultSetQ = Main.SQL1.ExecQuery(Query)
	ResultSetQ.NextRow

	If ResultSetQ.GetString("AvgCashTips") = Null Then
		nAvgCashTips = 0
	Else
		nAvgCashTips = ResultSetQ.GetDouble("AvgCashTips")
	End If

	ResultSetQ.Close
	
	Return nAvgCashTips
End Sub

Public Sub GetEmployerProfile(pEmployer As String) As List
	'Get Profile Record for hourly earnings
	Dim List1 As List
	List1.Initialize
	Dim Query1 As String
	Dim ResultSet1 As ResultSet
	Dim DeliveryFee, EgressTime, IngressTime, OffRoadWage, UseCashTips, OnRoadWage, PayPeriodStart, PayPeriod, Employer As String
	
	Try
		pEmployer = pEmployer.trim.ToUpperCase

		'MIN WAGE
		'ON ROAD WAGE
		Query1 = "SELECT * FROM employers WHERE UPPER(TRIM(Employer)) = " & "'" & pEmployer & "'"
		ResultSet1 = Main.SQL1.ExecQuery(Query1)
		ResultSet1.NextRow
		DeliveryFee = ResultSet1.GetString("DeliveryFee")
		EgressTime = ResultSet1.GetString("EgressTime")
		IngressTime = ResultSet1.GetString("IngressTime")
		OffRoadWage = ResultSet1.GetString("OffRoadHourlyRate")
		OnRoadWage = ResultSet1.GetString("OnRoadHourlyRate")
		UseCashTips = ResultSet1.GetString("ReportCashTips")  'YES OR NO on reporting cash tips
		PayPeriodStart = ResultSet1.GetString("LastPayPeriodThruDate")
		PayPeriod = ResultSet1.GetString("PayPeriod")
		Employer = ResultSet1.GetString("Employer")

		If Employer = Null Then
'			DialogBox("ERROR", "Missing Active Employer Profile Record.", "OK", "", "")
			Return List1
		End If

		If OffRoadWage = 0 And OnRoadWage = 0 Then
'			DialogBox("ERROR", "Missing Wage Information in Employer Profile Record.", "OK", "", "")
			Return List1
		End If

		If PayPeriodStart = "" Then
'			DialogBox("ERROR", "Missing Pay Week Information in Employer Profile Record.", "OK", "", "")
			Return List1
		End If
		
		List1.Add(OffRoadWage)
		List1.Add(OnRoadWage)
		List1.Add(UseCashTips)
		List1.Add(PayPeriodStart)
		List1.Add(PayPeriod)
		List1.Add(Employer)
		List1.Add(DeliveryFee)
		List1.Add(EgressTime)
		List1.Add(IngressTime)
		
		ResultSet1.Close
		
		Return List1
	Catch
		List1.Add(0)
		List1.Add(0)
		List1.Add("False")
		List1.Add("2000-01-01")
		List1.Add("Weekly")
		List1.Add("NoEmployer")
		List1.Add(0)
		List1.Add(0)
		List1.Add(0)
		Log(LastException)
		Return List1
	End Try
End Sub

Public Sub IsNaN(d As Double) As Boolean  'test for Illegal calculation
	Return d<>d
End Sub

Public Sub isValidDate(pDate As String) As Boolean
	DateTime.DateFormat = "yyyy-MM-dd"
	
	Try
		DateTime.DateParse(pDate)
	Catch
		Return False
	End Try
	
	Return True
End Sub

Public Sub CapitalizeAllFirstLetters(pWord As String) As String
	Dim str As String
	Dim str1 As String
	Dim str2 As String
	
	Dim l As List
	l = Regex.Split(" ", pWord)
	Dim x As String
	str = ""
	
	'Capitalize first letter of every word
	Try
		For i = 0 To l.Size-1
			x = l.Get(i)
			str1 = x.SubString2(0, 1)  'isolate first letter to capitalize
			str2 = x.SubString(1)  'the rest of the word
			If IsNumber(str1) = False Then  'So that Apt letter after a Number is not set to lower case
				str = str & str1.ToUpperCase & str2.ToLowerCase & " "
			Else
				str = str & str1.ToUpperCase & str2.ToUpperCase & " "
			End If
		Next
			
	Catch
		Return " "
	End Try
	
	Return str.Trim
End Sub

Public Sub WriteFile(Dir As String, FileName As String, List1 As List)
	Dim sb As StringBuilder
	sb.Initialize
	For Each line As Object In List1
		sb.Append(line).Append(CRLF)
	Next
	File.WriteString(Dir, FileName, sb.ToString)
End Sub


Public Sub GetNewTime(pDate As String, pTime As String, pSeconds As Int) As String
	'Adds Passed Seconds to or from time parameter
	Dim pTimeTicks As Long
	Dim TicksPerpSeconds As Long
	Dim NewTicks As Long
	Dim NewTime As String
	
	pTimeTicks = DateTime.DateTimeParse(pDate, pTime)
	TicksPerpSeconds = Abs(pSeconds) * DateTime.TicksPerSecond
	If pSeconds > 0 Then
		NewTicks = pTimeTicks + TicksPerpSeconds
	Else
		NewTicks = pTimeTicks - TicksPerpSeconds
	End If
	NewTime = DateTime.Time(NewTicks)
	
	Return NewTime
End Sub

Public Sub RemoveZipCode(pAddress As String) As String
	'Take off zip code, if present
	Dim Address As String
	Dim l As Int
	
	Address = pAddress
	Dim str1 As String
	l = Address.Trim.Length
	str1 = Address.SubString2(l-5,l)
	str1 = str1.trim
	If IsNumber(str1) Then
		Address = Address.SubString2(0,l-5)
		Address = Address.Trim
	Else
		Address = Address.Trim
	End If
	
	Return Address
End Sub

Public Sub GetZipCode(pAddress As String) As String
	'Take off zip code, if present
	Dim Address As String
	Dim l As Int
	
	Address = pAddress
	Dim Zip As String
	l = Address.Trim.Length
	Zip = Address.SubString2(l-5,l)
	Zip = Zip.trim
	
	Return Zip
End Sub

Public Sub GetTotalDeliveryFees(pEmployer As String, pStartPeriod As String, pEndPeriod As String) As Double
	Dim Query1 As String
	Dim ResultSet1 As ResultSet
	Dim TotalDeliveryFees As Double
	
	If pEmployer <> Main.Localize.Localize("All") Then
		Query1 = "SELECT SUM(DeliveryFee) As 'TotalDeliveryFees' FROM tips WHERE Employer = " & "'" & pEmployer & "'" & " AND TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "'" 
	Else
		Query1 = "SELECT SUM(DeliveryFee) As 'TotalDeliveryFees' FROM tips WHERE TipDate >= " & "'" & pStartPeriod & "'" & _
		         " AND TipDate <= " & "'" & pEndPeriod & "'" 
	End If
				 			 
	ResultSet1 = Main.SQL1.ExecQuery(Query1)
	ResultSet1.NextRow
	If ResultSet1.GetString("TotalDeliveryFees") = Null Then
		TotalDeliveryFees = 0
	Else
		TotalDeliveryFees = ResultSet1.GetDouble("TotalDeliveryFees")
	End If
	
	ResultSet1.Close
	
	Return TotalDeliveryFees
End Sub

Public Sub GetTipCredit(pEmployer As String, pStartDate As String, pEndDate As String) As Double
	Dim nDeliveryTimeInSecs As Int
	Dim nOnRoadEarnings As Double
	Dim nOnRoadEarningsMustPay As Double
	Dim EmployerProfile1 As List
	Dim nOnRoadWage As Double
	Dim nOffRoadWage As Double
	Dim UseCashTips As String
	Dim nTotalCashTips As Double
	Dim nTotalCreditTips As Double
	Dim MaxTipCredit As Double
	Dim ActualTipCredit As Double
	Dim nTotalTips As Double
	
	'Get Total Tips for Period Entered
	'CASH TIPS
	nTotalCashTips = GetTotalCashTips(pEmployer, pStartDate, pEndDate)
	
	'CREDIT TIPS
	nTotalCreditTips = GetTotalCreditTips(pEmployer, pStartDate, pEndDate)
	
	'Get Profile Record for hourly earnings
	'MIN WAGE
	'ON ROAD WAGE
	EmployerProfile1 = GetEmployerProfile(pEmployer)
	If EmployerProfile1.Size = 0 Then
		Return 0
	End If
	nOffRoadWage = EmployerProfile1.Get(0)
	nOnRoadWage = EmployerProfile1.Get(1)
	UseCashTips = EmployerProfile1.Get(2)
	
	'Get total hours worked on the road (DELIVERIES)
	'REDUCED WAGE x HOURS ON ROAD = ACTUAL EARNINGS BEFORE TIP CREDIT
	nDeliveryTimeInSecs = GetRoadHoursWorked(pEmployer, pStartDate, pEndDate)
	If nDeliveryTimeInSecs = -1 Then
		Return 0
	End If
	
	nOnRoadEarnings = (nDeliveryTimeInSecs/3600) * nOnRoadWage
	nOnRoadEarningsMustPay = (nDeliveryTimeInSecs/3600) * nOffRoadWage
	
	'MIN WAGE - ROAD WAGE = MAX AMT EMPLOYER MAY TAKE AS A TIP CREDIT
	MaxTipCredit = nOnRoadEarningsMustPay - nOnRoadEarnings
	
	'Get Total Tips
	If UseCashTips = "True" Then
		nTotalTips = nTotalCashTips + nTotalCreditTips
	Else
		nTotalTips = nTotalCreditTips
	End If
	
	'ACTUAL TIP CREDIT = Minimum of MaxTipCredit and TotalTips
	ActualTipCredit = Min(nTotalTips, MaxTipCredit)
	
	'If Both wages are the same, then no tip credit
	If nOffRoadWage = nOnRoadWage Then
		ActualTipCredit = 0
	End If
	
	Return ActualTipCredit
End Sub

Public Sub SetButtonTextColor(btn As Button, clr As Int, state As Int)
	'state: 0 = normal, 1 = pressed, 2 = disabled
	Dim no As NativeObject = btn
	no.RunMethod("setTitleColor:forState:", Array(no.ColorToUIColor(clr), state))
End Sub

Public Sub ConvertFractionTimeToMinutes(pTime As Double) As String
	'Ex: 3.50 = 3 hrs 30mins
	Dim strTime As String
	Dim Hours As String
	Dim Minutes As String
	Dim index As Int
	Dim nMins As Int
	Dim nHrs As Int
	Log("PARM " & pTime)
	Try
		strTime = NumberFormat(pTime, 0, 2)
		Log("STRTIME " & strTime)
		If strTime = 0 Then
			Return "00:00"
		End If
		
		index = strTime.IndexOf(".")
		Log("INDEX " & index)
		If index = 0  Then
			Hours = 0
		Else
			Hours = strTime.SubString2(0, index)
		End If
		nHrs = Hours
		Log("HOURS " & Hours)
		Minutes = strTime.SubString(index)
		Minutes = NumberFormat((60 * Minutes), 0, 0)
		nMins = Minutes
		If nMins = 60 Then
			nHrs = nHrs + 1
			nMins = 0
			Hours = nHrs
			Minutes = nMins
		End If
		Log("MINS " & Minutes)
		If Minutes.Length = 1 Then
			Minutes = "0" & Minutes
		End If
	
		Return Hours & ":" & Minutes
	Catch
		Return "00:00"
	End Try

End Sub

Public Sub GetTotalMiles(pEmployer As String, pFromDate As String, pThruDate As String) As Double
	Dim ResultSetQ As ResultSet
	Dim nTotalMiles As Double
	
	'Get Total Miles
	ResultSetQ = Main.SQL1.ExecQuery("SELECT SUM(TripMiles) as 'TotalMiles' FROM tips WHERE Employer = " & "'" & pEmployer & "'" & _
	                                " AND TipDate >= " & "'" & pFromDate & "'" & " AND TipDate <= " & "'" & pThruDate & "'")
	ResultSetQ.NextRow
	
	nTotalMiles = ResultSetQ.GetDouble("TotalMiles")
	
	Return nTotalMiles
End Sub

Public Sub GetMileageRate(pYear As String) As Double
	Dim ResultSetQ As ResultSet
	Dim nRate As Double
	
	ResultSetQ = Main.SQL1.ExecQuery("SELECT Rate FROM miledeductions WHERE Year = " & "'" & pYear & "'")
	ResultSetQ.NextRow
	If ResultSetQ.GetString("Rate") = Null Then
		nRate = 0
	Else
		nRate = ResultSetQ.GetDouble("Rate")
	End If
	
	Return nRate
End Sub

Public Sub RateApp
	Dim App As Application
	If App.OSVersion >= 10.3 Then
		Dim no As NativeObject
		no.Initialize("SKStoreReviewController").RunMethod("requestReview", Null)
	End If
End Sub


Public Sub GetVendorIdentifier As String
	Dim no As NativeObject
	no = no.Initialize("UIDevice").RunMethod("currentDevice", Null)
	Dim id As Object = no.GetField("identifierForVendor").GetField("UUIDString")
	Return id
End Sub


Public Sub SetCurrencySymbol
	'Replaces currency symbol in loaded strings map
	Main.strings.Put("$", Main.CurrencySymbol)
End Sub

Public Sub GetHourlyWages(pStartDate As String, pEndDate As String) As Double
	If Main.FirstUse = True Then
		Return 0
	End If
	Dim nShiftTimeInSecs As Int
	Dim EmployerProfile1 As List
	Dim nOffRoadWage As Double
	Dim nWages As Double
	Dim EndDate As String
	Dim EndTime As String
	Dim ShiftTime As String
	Dim PayPeriod As String
	Dim Overtime As Double
	Dim tempShiftStartTime As String
	
	'Not clocked in.  Give something to work with.  Have Shift Start Date when app is started
	If Main.ShiftStartTime = "" Then
		tempShiftStartTime = DateTime.Time(DateTime.Now)
		EndDate = DateTime.Date(DateTime.Now)
		EndTime = DateTime.Time(DateTime.Now)
		EndTime = GetNewTime(EndDate, EndTime, 1)
	Else
		tempShiftStartTime = Main.ShiftStartTime
		EndDate = DateTime.Date(DateTime.Now)
		EndTime = DateTime.Time(DateTime.Now)
	End If
	
	'Get Profile Record for hourly earnings
	'MIN WAGE
	'ON ROAD WAGE
	EmployerProfile1 = GetEmployerProfile(Main.ActiveEmployer)
	If EmployerProfile1.Size = 0 Then
		Return 0
	End If
	nOffRoadWage = EmployerProfile1.Get(0)
	PayPeriod = EmployerProfile1.Get(4)
	
	'Get Total Hours worked in shop for period entered (SHIFT)
	'This code is needed to force current shift to be used since no saved shift record exists, yet
	nShiftTimeInSecs = GetShiftHoursWorked(Main.ActiveEmployer, pStartDate, pEndDate)  'looking for saved record
	If nShiftTimeInSecs = 0 Then
		ShiftTime = TimeBetweenTwoDates(Main.ShiftStartDate, tempShiftStartTime, EndDate, EndTime)
		nShiftTimeInSecs = GetSecondsofTime(ShiftTime)
		If nShiftTimeInSecs = -1 Then
			Return 0
		End If
	End If

'	'After midnight, Wages will be reset to zero.  ELSE above will return zero because no saved shift record exists.  This code fixes this
'	If nShiftTimeInSecs = 0 Then
'		ShiftTime = GlobalFunctions.TimeBetweenTwoDates(Main.ShiftStartDate, tempShiftStartTime, EndDate, EndTime)
'		nShiftTimeInSecs = GlobalFunctions.GetSecondsofTime(ShiftTime)
'	End If
	
	'Calculate Overtime
	Overtime = CalcOvertime(nShiftTimeInSecs, nOffRoadWage, PayPeriod)
	
	nWages = ((nShiftTimeInSecs/3600) * nOffRoadWage) + Overtime

	Return nWages
End Sub

Public Sub GetPerHourRate(pEmployer As String, pShiftStartDate As String, pShiftEndDate As String) As Double
	Dim ShiftTime As String
	Dim TotalTips As Double
	Dim nDeliveryFees As Double
	Dim nOffRoadWage As Double
	Dim UseCashTips As String
	Dim nShiftTimeInSecs = 0 As Int
	Dim nMinGrossEarnings = 0 As Double
	Dim nTotalCashTips = 0 As Double
	Dim nTotalCreditTips = 0 As Double
	Dim nTipCredit = 0 As Double
	Dim nActualGrossEarnings = 0 As Double
	Dim EmployerProfile1 As List
	Dim nHourlyRate = 0 As Double
	Dim TempShiftStartTime As String
	Dim EndDate, EndTime As String

	'Not clocked in.  Give something to work with
	If Main.ShiftStartTime = "" Then
		TempShiftStartTime = DateTime.Time(DateTime.Now)
		EndDate = DateTime.Date(DateTime.Now)
		EndTime = DateTime.Time(DateTime.Now)
		EndTime = GetNewTime(EndDate, EndTime, 1)
	Else
		TempShiftStartTime = Main.ShiftStartTime
		EndDate = DateTime.Date(DateTime.Now)
		EndTime = DateTime.Time(DateTime.Now)
	End If
	
	'Get Profile Record for hourly earnings
	'MIN WAGE
	'ON ROAD WAGE
	EmployerProfile1 = GetEmployerProfile(pEmployer)
	If EmployerProfile1.Size = 0 Then
		Return -1.00  'test===================================================================was no return value when function was in mainscreen module
	End If
	nOffRoadWage = EmployerProfile1.Get(0)
	UseCashTips = EmployerProfile1.Get(2)
	
	'Get Total Cash Tips
	nTotalCashTips = GetTotalCashTips(pEmployer, pShiftStartDate, pShiftEndDate)
	
	'Get Total Credit Tips
	nTotalCreditTips = GetTotalCreditTips(pEmployer, pShiftStartDate, pShiftEndDate)

	'Get Total Hours worked in shop for period entered (SHIFT)
	'Can't use query, since shift hasn't ended
	nShiftTimeInSecs = GetShiftHoursWorked(pEmployer, pShiftStartDate, pShiftEndDate)  'looking for saved record
	If nShiftTimeInSecs = 0 Then
		ShiftTime = TimeBetweenTwoDates(Main.ShiftStartDate, TempShiftStartTime, EndDate, EndTime)
		nShiftTimeInSecs = GetSecondsofTime(ShiftTime)
		If nShiftTimeInSecs = -1 Then
			Return -1.00 'test===================================================================was no return value when function was in mainscreen module
		End If
	End If
	
	nMinGrossEarnings = ((nShiftTimeInSecs/3600) * nOffRoadWage)

	'Get Tip Credit
	nTipCredit = GetTipCredit(pEmployer, pShiftStartDate, pShiftEndDate)
	
	'Get Total Tips
	If UseCashTips = "True" Then
		TotalTips = nTotalCashTips + nTotalCreditTips
	Else
		TotalTips = nTotalCreditTips
	End If
	
	'IF TipCredit is less than Total Tips Add Difference to MIN GROSS EARNINGS
	If nTipCredit <= TotalTips Then
		If UseCashTips = "True" Then
			nActualGrossEarnings = nMinGrossEarnings + (TotalTips - nTipCredit)
		Else
			nActualGrossEarnings = nMinGrossEarnings + (TotalTips - nTipCredit) + nTotalCashTips
		End If
	Else
		nActualGrossEarnings = nMinGrossEarnings 'GROSS EARNINGS CALC REMAINS AS IS
	End If
	
	'Get Total Delivery Fees
	nDeliveryFees = GetTotalDeliveryFees(pEmployer, pShiftStartDate, pShiftEndDate)
	
	nHourlyRate = (nActualGrossEarnings + nDeliveryFees)/(nShiftTimeInSecs/3600)
	If IsNaN(nHourlyRate) Then
		nHourlyRate = 0  'nOffRoadWage
	End If
	
	'stop "Crazy" value from appearing until an hour has past
	If nShiftTimeInSecs/3600 < 1 Then
		nHourlyRate = nOffRoadWage
	End If
	
	Return nHourlyRate
	
End Sub

Public Sub HaveRecords As Boolean
	Dim ResultSetQ As ResultSet
	
	'Get Total Miles
	ResultSetQ = Main.SQL1.ExecQuery("SELECT COUNT(*) AS RecCount FROM tips")
	ResultSetQ.NextRow
	
	If ResultSetQ.GetInt("RecCount") = 0 Then
		Return False
	End If
	Log(ResultSetQ.GetInt("RecCount"))
	Return True
End Sub