﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.8
@EndOfDesignText@
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.
	Public PageMain As Page
	Public pnlSummary As Panel
	Private Drawer As B4XDrawer
	Private CustomListView1 As CustomListView
	
	Private btnShowToday As Button
	Private btnShowWeek As Button
	Private btnShowMonth As Button
	Private btnShowYear As Button
	Private lblAvgTips As Label
	Private lblCashTips As Label
	Private lblCreditTips As Label
	Private lblDeliveries As Label
	Private lblNumTips As Label
	Private lblNumStiffs As Label
	Private lblTipPercent As Label
	Private lblEmployer As Label
	Private btnSetShift As Button
	Private lblDeliveryFees As Label
	Private lblTipCredit As Label
	Private lblWages As Label
	
	Private lblMilesDriven As Label
	Private lblMileageExpense As Label
	Private lblHoursWorked As Label
	Private lblNetTips As Label
	Private lblTotalIncome As Label


	Private ImageViewDominos As ImageView
	Private ImageViewJimmyJohns As ImageView
	Private ImageViewPapaJohns As ImageView
	Private ImageViewGrubHub As ImageView
	Private ImageViewDoorDash As ImageView
	Private ImageViewPizzaHut As ImageView
	Private ImageViewUberEats As ImageView
	Private ImageViewPostMates As ImageView
	Private ImageViewInstacart As ImageView
	Private ImageViewCaviar As ImageView
	Private ImageViewPizzaGuy As ImageView
	
	Private lblPerHour As Label
	
	Private lblOffRoadTime, lblOnRoadTime As Label


End Sub

Public Sub ShowMainScreen
	PageMain.Initialize("PageMain")
	PageMain.Title = "iDeliverPro"
	
	'=========================== Function was between lines
	BuildMenu
	'===========================
	
	ResetLayout
	
	Main.NavControl.ShowPage(PageMain)

	'Set gradiant color to panel
	GlobalFunctions.SetTheme(pnlSummary, False)
	
End Sub

Private Sub PageMain_BarButtonClick (Tag As String)
	If Tag = "hamburger" Then
		Drawer.LeftOpen = Not(Drawer.LeftOpen)
	End If
End Sub

Private Sub SetNavColors(clr As Int)
	Dim bar As NativeObject = Main.NavControl
	bar.GetField("toolbar").RunMethod("setBarTintColor:", Array(bar.ColorToUIColor(clr)))
	bar = bar.GetField("navigationBar")
	bar.RunMethod("setBarTintColor:", Array(bar.ColorToUIColor(clr)))
	bar.SetField("translucent", False)
	Dim image As NativeObject
	image = image.Initialize("UIImage").RunMethod("new", Null)
	bar.RunMethod("setShadowImage:", Array(image))
	bar.RunMethod("setBackgroundImage:forBarMetrics:", Array(image, 0))
End Sub

Private Sub PageMain_Resize(Width As Int, Height As Int)
	Drawer.Resize(Width, Height)

End Sub

Private Sub CustomListView1_ItemClick (Position As Int, Value As Object)
	If Value = "Alerts" Then
		PageMain.ResignFocus
		AlertsRecords.ShowAlertsRecords
	End If
	If Value = "Charts and Graphs" Then
		If GlobalFunctions.HaveRecords = False Then
			GlobalFunctions.ToastMessage("No Records Exist to Graph.", True)
			Return
		End If
		PageMain.ResignFocus
		ChartsAndGraphs.ShowChartsAndGraphs
	End If
End Sub

Public Sub CloseMenu
'	Drawer.LeftOpen = Not(Drawer.LeftOpen)
	If Drawer.LeftOpen Then
		Drawer.LeftOpen = False
	End If
End Sub

#If OBJC
#import <AVFoundation/AVFoundation.h>
- (void) setAudioSession {
AVAudioSession *audioSession = [AVAudioSession sharedInstance];
BOOL ok;
NSError *setCategoryError = nil;
ok = [audioSession setCategory:AVAudioSessionCategoryPlayback
  error:&setCategoryError];
if (!ok) {
  NSLog(@"%s setCategoryError=%@", __PRETTY_FUNCTION__, setCategoryError);
}
}
#end if	

Private Sub ResetLayout
	Main.Localize.LocalizeLayout(PageMain.RootPanel)
End Sub

Private Sub BuildMenu
	Dim t = GetDeviceLayoutValues As Object
	Dim s = t As String

	SetNavColors(0xFFA9A9A9)       '(0xFFB0F1FF)
	Drawer.Initialize(Me, "drawer", PageMain.RootPanel, 165dip)
	If s = "375 x 667 (normalized scale)" Then
		Drawer.CenterPanel.LoadLayout("MainPage4")
	Else
		Drawer.CenterPanel.LoadLayout("MainPage")
	End If
	Drawer.LeftPanel.LoadLayout("left")

	Dim bb As BarButton
	bb.InitializeBitmap(LoadBitmapResize(File.DirAssets, "hamburger.png", 32dip, 32dip, True), "hamburger")
	PageMain.TopLeftButtons = Array(bb)

	CustomListView1.DefaultTextBackgroundColor = 0xFFA9A9A9
	
	Dim csAlerts As CSBuilder
	csAlerts.Initialize.Alignment("ALIGN_LEFT")
	csAlerts.Font(Font.CreateFontAwesome(14)).Append(Chr(0xF12A)).Append("  Alerts").Pop.Pop
	csAlerts.PopAll
		
	Dim csCharts As CSBuilder
	csCharts.Initialize.Alignment("ALIGN_LEFT")
	csCharts.Font(Font.CreateFontAwesome(14)).Append(Chr(0xF080)).Append("  Charts and Graphs").Pop.Pop
	csCharts.PopAll

	CustomListView1.AddTextItem(csAlerts, "Alerts")

	CustomListView1.AddTextItem(csCharts, "Charts and Graphs")

End Sub